import * as i0 from '@angular/core';
import { Injectable, Component, EventEmitter, Output, Pipe, Inject, Input, ViewChild, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { MatSidenavModule } from '@angular/material/sidenav';
import * as i2 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i4$1 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i8 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i3 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i5$1 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i5$2 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i6$1 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import * as i4$2 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatStepperModule } from '@angular/material/stepper';
import * as i9 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';
import * as i4 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import * as i4$3 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i6 from '@angular/material/core';
import { MAT_DATE_LOCALE, DateAdapter, MAT_DATE_FORMATS } from '@angular/material/core';
import { MatCardModule } from '@angular/material/card';
import * as i1 from '@angular/common/http';
import { HttpClientModule, HttpHeaders } from '@angular/common/http';
import * as i1$2 from '@angular/forms';
import { FormGroup, FormControl, Validators, ReactiveFormsModule, FormsModule } from '@angular/forms';
import { BehaviorSubject, of, timer, ReplaySubject, forkJoin, throwError } from 'rxjs';
import { transform, isEqual, isObject, merge } from 'lodash';
import * as i1$1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialog, MatDialogModule } from '@angular/material/dialog';
import * as i5 from '@angular/common';
import { registerLocaleData, CommonModule } from '@angular/common';
import * as moment from 'moment';
import { startWith, map, tap } from 'rxjs/operators';
import * as i4$4 from '@angular/material/slider';
import { MatSliderModule } from '@angular/material/slider';
import { MatMomentDateModule, MomentDateAdapter, MAT_MOMENT_DATE_FORMATS } from '@angular/material-moment-adapter';
import localeDe from '@angular/common/locales/de';
import { SelectionModel } from '@angular/cdk/collections';
import * as i7 from '@angular/material/table';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import * as i8$1 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as i6$2 from '@angular/material/paginator';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import * as i5$3 from '@angular/material/slide-toggle';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { ENTER, COMMA } from '@angular/cdk/keycodes';
import * as i5$4 from '@angular/material/chips';
import { MatChipsModule } from '@angular/material/chips';
import * as i1$3 from '@angular/router';

class FormbuilderService {
    constructor() { }
}
FormbuilderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
FormbuilderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class FormbuilderComponent {
    constructor() { }
    ngOnInit() {
    }
}
FormbuilderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormbuilderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormbuilderComponent, selector: "lib-formbuilder", ngImport: i0, template: `
    <p>
      formbuilder works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-formbuilder',
                    template: `
    <p>
      formbuilder works!
    </p>
  `,
                    styles: []
                }]
        }], ctorParameters: function () { return []; } });

class TranslationService {
    constructor(http) {
        this.http = http;
        // tslint:disable-next-line: no-output-on-prefix
        this.onLangChange = new EventEmitter();
        // tslint:disable-next-line: no-output-on-prefix
        this.onDataChange = new EventEmitter();
        this.data = {};
        this.lang = 'de';
        this.userData = {};
        this._path = '';
        this.onLangChange.subscribe(val => {
            this.lang = val;
        });
    }
    setPath(path) {
        this._path = path;
    }
    addTxtFile(path) {
        return new Promise((resolve, reject) => {
            const langPath = `${path}${this.lang || 'de'}.json`;
            // console.log(langPath);
            this.http.get(langPath).subscribe(translation => {
                // console.log(translation);
                this.updateData(translation);
                this.onDataChange.emit(this.data);
                resolve(this.data);
            }, error => {
                resolve(this.data);
            });
        });
    }
    getUserData() {
        let txtFile = {};
        for (const key in this.userData) {
            if (this.userData) {
                Object.assign(txtFile, {
                    [key]: this.data[key]
                });
            }
        }
        return txtFile;
    }
    setLang(lang) {
        this.lang = lang;
        this.use(this.lang);
        this.onLangChange.emit(this.lang);
    }
    updateData(data) {
        Object.assign(this.data, data);
        this.onDataChange.emit(this.data);
    }
    use(lang) {
        return new Promise((resolve, reject) => {
            const langPath = `${this._path}${lang || 'de'}.json`;
            // console.log(langPath);
            this.http.get(langPath).subscribe(translation => {
                // console.log(translation);
                this.data = Object.assign({}, translation || {});
                this.lang = lang;
                this.onDataChange.emit(this.data);
                resolve(this.data);
            }, error => {
                this.data = {};
                resolve(this.data);
            });
        });
    }
    deleteKeys(data) {
        // this.data.
        let newdata = {};
        for (let [key, value] of Object.entries(this.data)) {
            console.log(key + ':' + value);
            let found = false;
            for (let [key2, value2] of Object.entries(data)) {
                if (key !== key2) {
                    found = true;
                }
                // console.log(key + ':' + value);
            }
            if (!found) {
                Object.assign(newdata, { [key]: value });
            }
        }
        this.data = newdata;
    }
    getFBData() {
        let txtFile = {};
        for (const key in this.data) {
            if (!this.userData[key]) {
                Object.assign(txtFile, {
                    [key]: this.data[key]
                });
            }
        }
        return txtFile;
    }
}
TranslationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslationService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
TranslationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslationService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; }, propDecorators: { onLangChange: [{
                type: Output
            }], onDataChange: [{
                type: Output
            }] } });

class TranslatePipe {
    constructor(translate) {
        this.translate = translate;
    }
    transform(key) {
        // console.log(key);
        if (key !== 'undefined') {
            // console.log(this.translate.data);
            return this.translate.data[key] || '';
        }
    }
}
TranslatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslatePipe, deps: [{ token: TranslationService }], target: i0.ɵɵFactoryTarget.Pipe });
TranslatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslatePipe, name: "translate", pure: false });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TranslatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'translate',
                    pure: false
                }]
        }], ctorParameters: function () { return [{ type: TranslationService }]; } });

class ConfirmDialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'questionmark';
        this.errorMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.message) {
            this.message = this.data.message;
        }
        else {
            this.message = 'Sind Sie sicher?';
        }
        console.log(this.message);
    }
}
ConfirmDialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ConfirmDialogComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1$1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component });
ConfirmDialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: ConfirmDialogComponent, selector: "app-confirm-dialog", ngImport: i0, template: "<div id=\"confirm-dialog_title\">\n  <mat-icon class=\"md-48\">{{icon}}</mat-icon>\n  <h2>Sind Sie sicher?</h2>\n</div>\n\n<mat-dialog-content id=\"confirm-dialog_content\">\n\n  <p id=\"confirm-dialog_message\">{{message | translate}}</p>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-no\" class=\"button-big secondary\" mat-raised-button [mat-dialog-close]=\"false\">Nein\n  </button>\n  <div class=\"space-width-20\"></div>\n  <button id=\"error-dialog_button-yes\" class=\"button-big\" mat-raised-button [mat-dialog-close]=\"true\" color=\"primary\">\n    Ja\n  </button>\n</mat-dialog-actions>\n", styles: ["#confirm-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#confirm-dialog_title>h2{margin:0}#confirm-dialog_message{font-size:14px}mat-dialog-content#confirm-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"], components: [{ type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]" }, { type: i1$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ConfirmDialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-confirm-dialog', template: "<div id=\"confirm-dialog_title\">\n  <mat-icon class=\"md-48\">{{icon}}</mat-icon>\n  <h2>Sind Sie sicher?</h2>\n</div>\n\n<mat-dialog-content id=\"confirm-dialog_content\">\n\n  <p id=\"confirm-dialog_message\">{{message | translate}}</p>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-no\" class=\"button-big secondary\" mat-raised-button [mat-dialog-close]=\"false\">Nein\n  </button>\n  <div class=\"space-width-20\"></div>\n  <button id=\"error-dialog_button-yes\" class=\"button-big\" mat-raised-button [mat-dialog-close]=\"true\" color=\"primary\">\n    Ja\n  </button>\n</mat-dialog-actions>\n", styles: ["#confirm-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#confirm-dialog_title>h2{margin:0}#confirm-dialog_message{font-size:14px}mat-dialog-content#confirm-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }, { type: i1$1.MatDialogRef }];
    } });

class ErrorDialogSimpleComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'error';
        this.errorMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.errorMsg && Array.isArray(this.data.errorMsg)) {
            this.errorMsg = this.data.errorMsg;
        }
        else {
            this.errorMsg = [String(this.data.errorMsg)];
        }
    }
}
ErrorDialogSimpleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ErrorDialogSimpleComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1$1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component });
ErrorDialogSimpleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: ErrorDialogSimpleComponent, selector: "app-error-dialog-simple", ngImport: i0, template: "<div id=\"error-dialog_title\">\n  <mat-icon class=\"md-48 hipps-error-icon\">{{icon}}</mat-icon>\n  <h2 *ngIf=\"errorMsg.length < 2\">Es ist ein Fehler aufgetreten!</h2>\n  <h2 *ngIf=\"errorMsg.length > 1\">Es sind Fehler aufgetreten!</h2>\n</div>\n\n<mat-dialog-content id=\"error-dialog_content\">\n\n  <mat-list id=\"error-dialog_error-list\">\n    <mat-list-item class=\"error-dialog_message\" *ngFor=\"let msg of errorMsg\">{{errorMsg | translate}}</mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">\n    OK\n  </button>\n</mat-dialog-actions>\n", styles: ["#error-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#error-dialog_title>h2{margin:0}mat-list-item.error-dialog_message{font-size:14px;word-break:break-all}mat-dialog-content#error-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"], components: [{ type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i3.MatList, selector: "mat-list, mat-action-list", inputs: ["disableRipple", "disabled"], exportAs: ["matList"] }, { type: i3.MatListItem, selector: "mat-list-item, a[mat-list-item], button[mat-list-item]", inputs: ["disableRipple", "disabled"], exportAs: ["matListItem"] }, { type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]" }, { type: i1$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ErrorDialogSimpleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-error-dialog-simple', template: "<div id=\"error-dialog_title\">\n  <mat-icon class=\"md-48 hipps-error-icon\">{{icon}}</mat-icon>\n  <h2 *ngIf=\"errorMsg.length < 2\">Es ist ein Fehler aufgetreten!</h2>\n  <h2 *ngIf=\"errorMsg.length > 1\">Es sind Fehler aufgetreten!</h2>\n</div>\n\n<mat-dialog-content id=\"error-dialog_content\">\n\n  <mat-list id=\"error-dialog_error-list\">\n    <mat-list-item class=\"error-dialog_message\" *ngFor=\"let msg of errorMsg\">{{errorMsg | translate}}</mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"error-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">\n    OK\n  </button>\n</mat-dialog-actions>\n", styles: ["#error-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#error-dialog_title>h2{margin:0}mat-list-item.error-dialog_message{font-size:14px;word-break:break-all}mat-dialog-content#error-dialog_content{padding-left:60px!important;padding-right:60px!important}mat-icon{margin-right:20px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }, { type: i1$1.MatDialogRef }];
    } });

class InfoDialogSimpleComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        this.icon = 'info';
        this.infoMsg = [];
    }
    ngOnInit() {
        if (!this.data) {
            return;
        }
        this.dialogRef.disableClose = true;
        if (!!this.data.icon) {
            this.icon = this.data.icon;
        }
        if (!!this.data.infoMsg && Array.isArray(this.data.infoMsg)) {
            this.infoMsg = this.data.infoMsg;
        }
        else {
            this.infoMsg = [String(this.data.infoMsg)];
        }
    }
}
InfoDialogSimpleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: InfoDialogSimpleComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1$1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component });
InfoDialogSimpleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: InfoDialogSimpleComponent, selector: "app-info-dialog-simple", ngImport: i0, template: "<div id=\"info-dialog_title\">\n  <mat-icon class=\"md-48 hipps-warning-icon\">{{icon}}</mat-icon>\n  <h2>Information</h2>\n</div>\n\n<mat-dialog-content id=\"info-dialog_content\">\n\n  <mat-list id=\"info-dialog_info-list\">\n    <mat-list-item *ngFor=\"let msg of infoMsg\"\n                   class=\"info-dialog_message\">\n                   {{infoMsg | translate}}\n    </mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"info-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">OK</button>\n</mat-dialog-actions>\n", styles: ["#info-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#info-dialog_title>h2{margin:0}mat-list-item.info-dialog_message{font-size:14px;height:20px;padding:0;word-break:break-all}mat-dialog-content#info-dialog_content{padding-left:50px!important;padding-right:50px!important}mat-icon{margin-right:20px}\n"], components: [{ type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i3.MatList, selector: "mat-list, mat-action-list", inputs: ["disableRipple", "disabled"], exportAs: ["matList"] }, { type: i3.MatListItem, selector: "mat-list-item, a[mat-list-item], button[mat-list-item]", inputs: ["disableRipple", "disabled"], exportAs: ["matListItem"] }, { type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i1$1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1$1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]" }, { type: i1$1.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: InfoDialogSimpleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-info-dialog-simple', template: "<div id=\"info-dialog_title\">\n  <mat-icon class=\"md-48 hipps-warning-icon\">{{icon}}</mat-icon>\n  <h2>Information</h2>\n</div>\n\n<mat-dialog-content id=\"info-dialog_content\">\n\n  <mat-list id=\"info-dialog_info-list\">\n    <mat-list-item *ngFor=\"let msg of infoMsg\"\n                   class=\"info-dialog_message\">\n                   {{infoMsg | translate}}\n    </mat-list-item>\n  </mat-list>\n\n</mat-dialog-content>\n\n<mat-dialog-actions class=\"flex-center\">\n  <button id=\"info-dialog_button-ok\" class=\"button-big\" mat-raised-button cdkFocusInitial [mat-dialog-close]=\"true\"\n          color=\"primary\">OK</button>\n</mat-dialog-actions>\n", styles: ["#info-dialog_title{display:flex;justify-content:flex-start;align-items:center;padding:30px 60px 0}#info-dialog_title>h2{margin:0}mat-list-item.info-dialog_message{font-size:14px;height:20px;padding:0;word-break:break-all}mat-dialog-content#info-dialog_content{padding-left:50px!important;padding-right:50px!important}mat-icon{margin-right:20px}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }, { type: i1$1.MatDialogRef }];
    } });

class DialogService {
    constructor(dialog) {
        this.dialog = dialog;
    }
    showDataImportErrorDialog(errorDataArray, afterDialogCallback) {
        const dialogData = {
            dataImportErrors: errorDataArray
        };
        const dialogRef = this.dialog.open(MatDialog, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            afterDialogCallback(result);
        });
        return dialogRef;
    }
    showErrorDialog(errorMsg, afterDialogCallback) {
        const dialogData = {
            errorMsg: errorMsg
        };
        const dialogRef = this.dialog.open(ErrorDialogSimpleComponent, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (!!afterDialogCallback) {
                afterDialogCallback(result);
            }
        });
        return dialogRef;
    }
    showInfoDialog(infoMsg, afterDialogCallback) {
        const dialogData = {
            infoMsg: infoMsg
        };
        const dialogRef = this.dialog.open(InfoDialogSimpleComponent, {
            data: dialogData,
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (!!afterDialogCallback) {
                afterDialogCallback(result);
            }
        });
        return dialogRef;
    }
    /**
     * messageString may also be an html String like:
     * <b>Are you sure?</b>
     *
     * @param {string} messageString
     * @param {Function} positiveCallback
     * @param {Function} negativeCallback
     */
    confirm(messageString, positiveCallback, negativeCallback) {
        console.log(messageString);
        const dialogData = {
            message: messageString
        };
        const dialogRef = this.dialog.open(ConfirmDialogComponent, {
            data: dialogData
        });
        dialogRef.afterClosed().subscribe((result) => {
            if (result === true) {
                positiveCallback();
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
    xmlExport(positiveCallback, negativeCallback) {
        const dialogRef = this.dialog.open(MatDialog);
        dialogRef.afterClosed().subscribe((result) => {
            if (result) {
                positiveCallback(result);
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
    setValid(positiveCallback, negativeCallback) {
        const dialogRef = this.dialog.open(MatDialog, { width: '350px' });
        dialogRef.afterClosed().subscribe((result) => {
            if (result) {
                positiveCallback(result);
            }
            else {
                if (!!negativeCallback) {
                    negativeCallback();
                }
            }
        });
    }
}
DialogService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DialogService, deps: [{ token: i1$1.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
DialogService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DialogService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DialogService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialog }]; } });

function difference(newObj, origObj) {
    let arrayIndexCounter = 0;
    return transform(newObj, (result, value, key) => {
        if (!isEqual(value, origObj[key])) {
            let resultKey = typeof (origObj === 'array') ? arrayIndexCounter++ : key;
            result[resultKey] =
                isObject(value) && isObject(origObj[key])
                    ? difference(value, origObj[key])
                    : value;
        }
    });
}
class FormService {
    constructor(fb, ds, tp) {
        this.fb = fb;
        this.ds = ds;
        this.tp = tp;
        this.forms = new FormGroup({});
        this.configChange = new BehaviorSubject([]);
        this.fieldchange = new BehaviorSubject([]);
        this.fields = [];
        this.emptyObj = {
            name: 'home_ui_new'
        };
        this.fieldchange.subscribe(val => {
            this.fields.push(val);
        });
        this.configChange.subscribe((newVal) => {
            // this.setUp(newVal);
        });
    }
    getFields() {
        return this.fields;
    }
    getFieldByName(name) {
        return this.fields.find(field => field.name === name);
    }
    addField(val) {
        this.fieldchange.next(val);
    }
    /**
     * @param form : FormGroup
     * @param name : FormName
     * @description adds form to Service of creates one
     */
    addForm(form, pageName) {
        if (this.forms !== undefined && this.forms !== null) {
            if (this.forms.get(pageName)) {
                let tmpForm = this.forms.get(pageName);
                Object.assign(tmpForm, form);
                this.forms.removeControl(pageName);
                this.forms.addControl(pageName, tmpForm);
            }
            else {
                this.forms.addControl(pageName, form);
            }
        }
        else {
            this.forms = this.fb.group({ [pageName]: form });
        }
    }
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description adds Config to Service
     */
    addConfig(config) {
        if (this.configs !== undefined && this.configs !== null) {
            for (const [pageName, page] of Object.entries(config)) {
                for (const [formName, form] of Object.entries(page)) {
                    let controls = {};
                    for (const [fieldName, field] of Object.entries(form)) {
                        controls[fieldName] = field;
                    }
                    if (this.configs[pageName][formName]) {
                        Object.assign(this.configs[pageName][formName], controls);
                    }
                    else {
                        this.configs[pageName][formName] = controls;
                    }
                }
            }
        }
        else {
            this.configs = config;
        }
        this.configChange.next(this.configs);
        this.setUp(this.configs);
    }
    /* TODO: has to be integrated */
    updateConfig(config) {
        const keys = config.name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            this.configs[page][form][key] = config;
            // this.configChange.next(this.configs);
            this.updateControl(config);
        }
    }
    updateControl(field) {
        const validatorS = this.buildValidators(field.validators);
        const controL = [];
        controL.push(field.value ? field.value : '');
        const options = {
            validators: [],
            updateOn: ''
        };
        if (validatorS) {
            options.validators = validatorS;
        }
        if (field.updateOn) {
            options.updateOn = field.updateOn;
            controL.push(options);
        }
    }
    /**
     * @param name : Page_Form_Field
     * @returns FieldConfig: IField
     */
    getConfigByName(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            return this.configs[page][form][key]
                ? this.configs[page][form][key]
                : this.emptyObj;
        }
        else {
            return this.emptyObj;
        }
    }
    /**
     * @param field : IField
     * @returns FormControl
     */
    getFormControl(field) {
        const keys = field.name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.forms.get(page).get(form).get(field.name)) {
            return this.forms.get(page).get(form).get(field.name);
        }
        else {
            return new FormControl('', this.buildValidators(field.validators));
        }
    }
    /**
     * @param name : Page_Form_Field
     * @returns Parent Form of key
     */
    getForm(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        if (this.forms.get([page, form])) {
            return this.forms.get(page).get(form);
        }
        else {
            if (this.forms.get(page)) {
                return this.forms.get(page);
            }
            else {
                return new FormGroup({});
            }
        }
    }
    /**
     * @param name : Name of Page
     * @returns Formgroup with forms of Page
     */
    getPage(name) {
        if (this.forms.get(name)) {
            return this.forms.get(name);
        }
        else {
            return null;
        }
    }
    /* TODO: has to be checked */
    getForms() {
        return this.forms.getRawValue();
    }
    /* TODO: has to be checked */
    getConfigs() {
        return this.configs;
    }
    /**
     * @param config : IValidator
     * @returns Array with ValidatorFunctions
     */
    buildValidators(config) {
        const validators = [];
        if (config) {
            if (config.email) {
                validators.push(Validators.email);
            }
            if (config.max) {
                validators.push(Validators.max(config.max));
            }
            if (config.required) {
                validators.push(Validators.required);
            }
            if (config.min) {
                validators.push(Validators.min(config.min));
            }
            if (config.maxLength) {
                validators.push(Validators.maxLength(config.maxLength));
            }
            if (config.minLength) {
                validators.push(Validators.minLength(config.minLength));
            }
            if (config.pattern) {
                validators.push(Validators.pattern(config.pattern));
            }
        }
        return validators;
    }
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description : FormGroup will be initalized and added by config [triggert in addConfig()]
     */
    setUp(config) {
        Object.keys(config).forEach(page => {
            const newForm = {};
            const formObj = config[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const formArray = {};
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        const validatorS = this.buildValidators(field.validators);
                        const controL = [];
                        controL.push({
                            value: field.value ? field.value : '',
                            disabled: field.disabled ? field.disabled : false
                        });
                        const options = {
                            validators: [],
                            updateOn: ''
                        };
                        if (validatorS) {
                            options.validators = validatorS;
                        }
                        if (field.updateOn) {
                            options.updateOn = field.updateOn;
                        }
                        controL.push(options);
                        formArray[field.name] = controL;
                    });
                    newForm[form] = this.fb.group(formArray);
                    this.addForm(this.fb.group(newForm), page);
                });
                this.buildCustomValidation(config);
            }
        });
        this.changes = this.forms.getRawValue();
    }
    buildCustomValidation(config) {
        Object.keys(config).forEach(page => {
            const formObj = config[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const formArray = {};
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (field.customValidation) {
                            Object.keys(field.customValidation).forEach(validation => {
                                // console.log(field.customValidation[validation]);
                                let fieldToCheck = null;
                                const validationObj = field.customValidation[validation];
                                const fieldD = this.getFormControl(field);
                                // console.log(validationObj.dialog.msg);
                                fieldD.valueChanges.subscribe((val) => {
                                    // console.log(this.tp.transform(validationObj.dialog.msg));
                                    let getChange = false;
                                    if (validationObj.fieldToCheck) {
                                        fieldToCheck = this.getFormControl({ name: validationObj.fieldToCheck });
                                    }
                                    else {
                                        fieldToCheck = fieldD;
                                        getChange = true;
                                    }
                                    switch (validationObj.operator) {
                                        case '<':
                                            break;
                                        case '>':
                                            break;
                                        case '=':
                                            break;
                                        case '!=':
                                            if (getChange) {
                                                if (this.getControlChange(field.name) !== val) {
                                                    // console.log('controlchange');
                                                    this.ds.confirm(validationObj.dialog.msg, () => {
                                                        this.applieChanges();
                                                    }, () => {
                                                        // console.log('reset '+ field.name);
                                                        this.resetControl(field.name);
                                                    });
                                                }
                                            }
                                            else {
                                                if (fieldToCheck && fieldToCheck.value !== val) {
                                                    // console.log('valuechange');
                                                    this.ds.confirm(validationObj.dialog.msg, () => { }, () => {
                                                        this.resetControl(field.name);
                                                    });
                                                }
                                                // } else {
                                            }
                                            break;
                                    }
                                });
                            });
                        }
                    });
                });
            }
        });
    }
    onConfigChange() {
        return this.configChange;
    }
    hasChanges() {
        return difference(this.forms.getRawValue(), this.changes);
    }
    resetForms() {
        if (this.forms) {
            this.forms.patchValue(this.changes);
        }
    }
    resetControl(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        if (this.changes[page][form][name] ||
            typeof this.changes[page][form][name] === 'string') {
            this.forms.get(page).get(form).get(name).patchValue(this.changes[page][form][name]);
            // this.resetForm();
            this.getFormControl({ name }).markAsUntouched();
            // this.getFormControl({name}).patchValue(this.changes[page][form][control]);
        }
    }
    getControlChange(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        return this.changes[page][form][name];
    }
    applieChanges() {
        this.changes = this.forms.getRawValue();
    }
    update() {
        this.forms.updateValueAndValidity();
    }
}
FormService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormService, deps: [{ token: i1$2.FormBuilder }, { token: DialogService }, { token: TranslatePipe }], target: i0.ɵɵFactoryTarget.Injectable });
FormService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: DialogService }, { type: TranslatePipe }]; } });

class BaseFieldComponent {
    constructor(fb, fs, ts) {
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.MSGerrors = {
            required: () => this.ts.data.required_error,
            maxlength: param => this.ts.data.minLength_error.replace('${param}', param.requiredLength),
            minlength: param => this.ts.data.minLength_error.replace('${param}', param.requiredLength),
            max: param => this.ts.data.max_error.replace('${param}', param.max),
            min: param => this.ts.data.min_error.replace('${param}', param.min),
            pattern: param => this.ts.data.pattern_error.replace('${param}', param.requiredPattern),
            email: () => this.ts.data.email_error,
            matDatepickerParse: () => this.ts.data.datepicker_error
        };
        this.name = 'home_ui_new';
        this.value = '';
        this.disabled = false;
        this.hintlabel = '';
        this.hint = '';
        this.tooltip = '';
        this.htmlType = 'text';
        this.iconAction = new EventEmitter();
        this.autocomplete = 'off';
        this.change = new EventEmitter();
        this.init = true;
    }
    get() {
        return this;
    }
    getErrorMeesage() {
        if (this.control) {
            for (const error in this.control.errors) {
                if ((this.control.errors.hasOwnProperty(error) && this.control.touched) ||
                    this.control.dirty) {
                    return this.getMeesage(error, this.control.errors[error]);
                }
            }
        }
    }
    getMeesage(type, param) {
        // console.log(type);
        if (this.MSGerrors[type](param)) {
            return this.MSGerrors[type](param);
        }
    }
    ngOnInit() {
        this.field = this.fs.getConfigByName(this.placeholder ? this.placeholder : this.name);
        this.setUpConfig(this.field);
        this.form = this.fs.getForm(this.field.name);
        // console.log(this.field);
        // console.log(this.name);
        this.control = this.fs.getFormControl(this.field);
        // console.log(this.control);
        if (this.init) {
            this.fs.addField(this);
        }
        this.init = false;
        this.control.valueChanges.subscribe(val => (this.value = val));
    }
    setUpConfig(config) {
        this.hint = config.hint;
        this.hintlabel = config.hintlabel;
        if (!this.hintlabel) {
            this.hintlabel = config.name + '#hintlabel';
        }
        let tmpReq = false;
        let tmpDis = false;
        if (this.init) {
            tmpReq = this.required ? this.required : null;
            tmpDis = this.disabled ? this.disabled : null;
        }
        this.validators = config.validators;
        this.disabled = config.disabled ? config.disabled : tmpDis;
        this.required = config.validators ? config.validators.required : tmpReq;
        // console.log(this.required);
        this.max = config.validators
            ? config.validators.max
            : this.max
                ? this.max
                : null;
        this.min = config.validators
            ? config.validators.min
            : this.min
                ? this.min
                : null;
        this.maxLength = config.validators
            ? config.validators.maxLength
            : this.maxLength
                ? this.maxLength
                : null;
        this.minLength = config.validators
            ? config.validators.minLength
            : this.minLength
                ? this.minLength
                : null;
        this.value = config.value || '';
        this.htmlType = config.htmlType ? config.htmlType : this.htmlType;
        this.iconBtn = config.icon ? config.icon : this.iconBtn;
        if (config.htmlAttribute && config.htmlAttribute.autocomplete) {
            this.autocomplete = config.htmlAttribute.autocomplete;
        }
        if (this.field.disabled && this.control) {
            this.control.disable();
        }
        this.synchronizeValidator();
    }
    getValue() {
        return this.ts.data[this.value + '#label'] || this.value;
    }
    getName() {
        return this.placeholder ? this.placeholder : this.name;
    }
    synchronizeValidator() {
        const newValidators = {};
        if (this.required) {
            newValidators.required = this.required;
        }
        if (this.max) {
            newValidators.max = this.max;
        }
        if (this.min) {
            newValidators.min = this.min;
        }
        if (this.maxLength) {
            newValidators.maxLength = this.maxLength;
        }
        if (this.minLength) {
            newValidators.minLength = this.minLength;
        }
        if (this.validators && this.validators.pattern) {
            newValidators.pattern = this.validators.pattern;
        }
        if (this.validators && this.validators.email) {
            newValidators.email = this.validators.email;
        }
        this.validators = newValidators;
    }
    getValidators() {
        return this.validators ? this.validators : {};
    }
    getFieldConfig() {
        return this;
    }
    iconAct() {
        this.iconAction.emit({
            name: this.getName(),
            value: this.getValue(),
            btn: this.iconBtn
        });
    }
}
BaseFieldComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: BaseFieldComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
BaseFieldComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: BaseFieldComponent, selector: "app-base-field", inputs: { name: "name", value: "value", placeholder: "placeholder", disabled: "disabled", minLength: "minLength", maxLength: "maxLength", min: "min", max: "max", required: "required", form: "form", control: "control", hintlabel: "hintlabel", hint: "hint", tooltip: "tooltip", htmlType: "htmlType", iconBtn: "iconBtn", iconAction: "iconAction", validators: "validators", customValidation: "customValidation", htmlAttribute: "htmlAttribute", autocomplete: "autocomplete", change: "change" }, ngImport: i0, template: '<div></div>', isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: BaseFieldComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'app-base-field',
                    template: '<div></div>'
                }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { name: [{
                type: Input
            }], value: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], disabled: [{
                type: Input
            }], minLength: [{
                type: Input
            }], maxLength: [{
                type: Input
            }], min: [{
                type: Input
            }], max: [{
                type: Input
            }], required: [{
                type: Input
            }], form: [{
                type: Input
            }], control: [{
                type: Input
            }], hintlabel: [{
                type: Input
            }], hint: [{
                type: Input
            }], tooltip: [{
                type: Input
            }], htmlType: [{
                type: Input
            }], iconBtn: [{
                type: Input
            }], iconAction: [{
                type: Input
            }], validators: [{
                type: Input
            }], customValidation: [{
                type: Input
            }], htmlAttribute: [{
                type: Input
            }], autocomplete: [{
                type: Input
            }], change: [{
                type: Input
            }] } });

class SelectComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.multiple = false;
    }
    ngOnInit() {
        super.ngOnInit();
        this.options = this.fs.getConfigByName(this.name).options ? this.fs.getConfigByName(this.name).options : this.options;
        this.multiple = this.fs.getConfigByName(this.name).multiple ? this.fs.getConfigByName(this.name).multiple : this.multiple;
        // console.log(this.options);
        // console.log(this.form);
    }
}
SelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SelectComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
SelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: SelectComponent, selector: "app-select", inputs: { options: "options", multiple: "multiple" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <mat-select [placeholder]=\"getName()+'#label' | translate\"\n                [formControlName]=\"name\"\n                [minlength]=\"validators.minLength\"\n                [maxlength]=\"validators.maxLength\"\n                [matTooltip]=\"getName()+'#tooltip' | translate\"\n                [required]=\"required\"\n                matTooltipDisabled=\"false\"\n                matTooltipHideDelay=\"200\"\n                matTooltipPosition=\"above\"\n                matTooltipShowDelay=\"100\"\n                [multiple]=\"multiple\"\n                [value]=\"value\"\n                (selectionChange)=\"change.emit({type: name, value: $event.value})\">\n    <div *ngIf=\"options && options[0] && options[0].key\">\n    <mat-option *ngIf=\"!required && !multiple\" [matTooltip]=\"'reset' | translate\" value=\"\">{{'please_choose' | translate}}</mat-option>\n      <mat-option *ngFor=\"let item of options\" [matTooltip]=\"item.description | translate\" [value]=\"item.value\">\n        {{item.key | translate}}\n      </mat-option>\n    </div>\n    </mat-select>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i5$1.MatSelect, selector: "mat-select", inputs: ["disabled", "disableRipple", "tabIndex"], exportAs: ["matSelect"] }, { type: i6.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i1$2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { type: i1$2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-select', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <mat-select [placeholder]=\"getName()+'#label' | translate\"\n                [formControlName]=\"name\"\n                [minlength]=\"validators.minLength\"\n                [maxlength]=\"validators.maxLength\"\n                [matTooltip]=\"getName()+'#tooltip' | translate\"\n                [required]=\"required\"\n                matTooltipDisabled=\"false\"\n                matTooltipHideDelay=\"200\"\n                matTooltipPosition=\"above\"\n                matTooltipShowDelay=\"100\"\n                [multiple]=\"multiple\"\n                [value]=\"value\"\n                (selectionChange)=\"change.emit({type: name, value: $event.value})\">\n    <div *ngIf=\"options && options[0] && options[0].key\">\n    <mat-option *ngIf=\"!required && !multiple\" [matTooltip]=\"'reset' | translate\" value=\"\">{{'please_choose' | translate}}</mat-option>\n      <mat-option *ngFor=\"let item of options\" [matTooltip]=\"item.description | translate\" [value]=\"item.value\">\n        {{item.key | translate}}\n      </mat-option>\n    </div>\n    </mat-select>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { options: [{
                type: Input
            }], multiple: [{
                type: Input
            }] } });

class TextInputComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.rows = 3;
        this.internalType = 'text';
    }
    ngOnInit() {
        super.ngOnInit();
    }
}
TextInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TextInputComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
TextInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: TextInputComponent, selector: "app-text-input", inputs: { rows: "rows", internalType: "internalType" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field *ngIf=\"htmlType === 'text'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n      <input\n        matInput\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [max]=\"validators.max\"\n        [min]=\"validators.min\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"internalType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\"\n        [autocomplete]=\"autocomplete\"/>\n      <button\n        (click)=\"iconAct()\"\n        *ngIf=\"iconBtn && value\"\n        mat-icon-button\n        matSuffix>\n        <mat-icon>{{ iconBtn }}</mat-icon>\n      </button>\n    <!-- <button (click)=\"value=''\" *ngIf=\"value\" aria-label=\"Clear\" mat-button mat-icon-button matSuffix>\n      <mat-icon>{{iconBtn}}</mat-icon>\n    </button> -->\n    <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n  <mat-form-field *ngIf=\"htmlType === 'textarea'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <textarea\n        matInput\n        [rows]=\"rows\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"htmlType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\">\n      </textarea>\n  <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n  <mat-error>\n    {{ getErrorMeesage() }}\n  </mat-error>\n</mat-form-field>\n</ng-container>\n", styles: ["mat-form-field{width:100%;max-width:auto}\n"], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i1$2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { type: i1$2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i4$1.MatSuffix, selector: "[matSuffix]" }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TextInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-text-input', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field *ngIf=\"htmlType === 'text'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n      <input\n        matInput\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [max]=\"validators.max\"\n        [min]=\"validators.min\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"internalType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\"\n        [autocomplete]=\"autocomplete\"/>\n      <button\n        (click)=\"iconAct()\"\n        *ngIf=\"iconBtn && value\"\n        mat-icon-button\n        matSuffix>\n        <mat-icon>{{ iconBtn }}</mat-icon>\n      </button>\n    <!-- <button (click)=\"value=''\" *ngIf=\"value\" aria-label=\"Clear\" mat-button mat-icon-button matSuffix>\n      <mat-icon>{{iconBtn}}</mat-icon>\n    </button> -->\n    <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n  <mat-form-field *ngIf=\"htmlType === 'textarea'\" [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <textarea\n        matInput\n        [rows]=\"rows\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [formControlName]=\"name\"\n        [minlength]=\"validators.minLength\"\n        [maxlength]=\"validators.maxLength\"\n        [placeholder]=\"getName() + '#label' | translate\"\n        [required]=\"required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        [type]=\"htmlType\"\n        (change)=\"change.emit({ type: name, value: $event.target.value })\"\n        [value]=\"value\">\n      </textarea>\n  <mat-hint *ngIf=\"hint\">{{ hint }}</mat-hint>\n  <mat-error>\n    {{ getErrorMeesage() }}\n  </mat-error>\n</mat-form-field>\n</ng-container>\n", styles: ["mat-form-field{width:100%;max-width:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { rows: [{
                type: Input
            }], internalType: [{
                type: Input
            }] } });

class DateInputComponent extends BaseFieldComponent {
    constructor(fb, fs, dateAdapter, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.dateAdapter = dateAdapter;
        this.ts = ts;
        dateAdapter.setLocale(ts.lang);
        ts.onLangChange.subscribe(lang => dateAdapter.setLocale(lang));
    }
    ngOnInit() {
        super.ngOnInit();
    }
    isMoment(date) {
        if (!moment.isMoment(date.value)) {
            date.patchValue(moment(date.value, 'L', 'de', true));
        }
    }
    keyup() {
        this.isMoment(this.control);
        this.control.patchValue(this.control.value.add(1, 'd'));
    }
    keydown() {
        this.isMoment(this.control);
        this.control.patchValue(this.control.value.subtract(1, 'd'));
    }
}
DateInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DateInputComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: i6.DateAdapter }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
DateInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: DateInputComponent, selector: "app-date-input", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <input matInput\n           [placeholder]=\"getName()+'#label' | translate\"\n           [formControlName]=\"name\"\n           [min]=\"validators.min\"\n           [max]=\"validators.max\"\n           [matTooltip]=\"getName()+'#tooltip' | translate\"\n           [required]=\"required\"\n           matTooltipDisabled=\"false\"\n           matTooltipHideDelay=\"200\"\n           matTooltipPosition=\"above\"\n           matTooltipShowDelay=\"100\"\n           [value]=\"getValue()\"\n           (keyup.arrowup)=\"keyup()\"\n           (keyup.arrowdown)=\"keydown()\"\n           [matDatepicker]=\"picker\">\n    <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n    <mat-datepicker #picker></mat-datepicker>\n    <mat-hint *ngIf=\"hint\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i6$1.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }, { type: i6$1.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i6$1.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i4$1.MatSuffix, selector: "[matSuffix]" }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DateInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-date-input', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName()+'#hintlabel' | translate\">\n    <input matInput\n           [placeholder]=\"getName()+'#label' | translate\"\n           [formControlName]=\"name\"\n           [min]=\"validators.min\"\n           [max]=\"validators.max\"\n           [matTooltip]=\"getName()+'#tooltip' | translate\"\n           [required]=\"required\"\n           matTooltipDisabled=\"false\"\n           matTooltipHideDelay=\"200\"\n           matTooltipPosition=\"above\"\n           matTooltipShowDelay=\"100\"\n           [value]=\"getValue()\"\n           (keyup.arrowup)=\"keyup()\"\n           (keyup.arrowdown)=\"keydown()\"\n           [matDatepicker]=\"picker\">\n    <mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n    <mat-datepicker #picker></mat-datepicker>\n    <mat-hint *ngIf=\"hint\">{{hint}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: i6.DateAdapter }, { type: TranslationService }]; } });

class FileInputComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.name);
        // console.log(this.control);
        // console.log(this.form);
    }
    onFileSelected() {
        const inputNode = document.querySelector('#file');
        if (typeof (FileReader) !== 'undefined' && typeof (inputNode.files[0]) !== 'undefined') {
            const reader = new FileReader();
            reader.onload = (e) => {
                // console.log(e);
                this.srcResult = e.target.result;
            };
            reader.readAsArrayBuffer(inputNode.files[0]);
            // console.log(reader);
        }
    }
}
FileInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FileInputComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
FileInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FileInputComponent, selector: "app-file-input", inputs: { srcResult: "srcResult" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <button type=\"button\" mat-raised-button (click)=\"fileInput.click()\">\n    Choose File\n  </button>\n  <input class=\"mat-input\" (change)=\"onFileSelected()\" #fileInput type=\"file\" id=\"file\"\n    [formControlName]=\"name\">\n</ng-container>", styles: [""], components: [{ type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FileInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-file-input', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <button type=\"button\" mat-raised-button (click)=\"fileInput.click()\">\n    Choose File\n  </button>\n  <input class=\"mat-input\" (change)=\"onFileSelected()\" #fileInput type=\"file\" id=\"file\"\n    [formControlName]=\"name\">\n</ng-container>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { srcResult: [{
                type: Input
            }] } });

const _filter = (opt, value, ts) => {
    const filterValue = value.toLowerCase();
    if (opt) {
        if (typeof opt[0] === 'string') {
            return opt.filter(item => checkKey(ts, item, filterValue));
        }
        else {
            return opt.filter(item => checkKey(ts, item.name, filterValue));
        }
    }
    else {
        return [];
    }
};
function checkKey(ts, item, value) {
    if (item.toLocaleLowerCase().indexOf(value) >= 0) {
        return true;
    }
    if (ts.data[item] && ts.data[item].toLocaleLowerCase().indexOf(value) >= 0) {
        return true;
    }
    return false;
}
class AutocompleteComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.config = {
            groupBy: true
        };
    }
    ngOnInit() {
        super.ngOnInit();
        if (this.config.groupBy) {
            this.filteredStates = this.control.valueChanges.pipe(
            // @ts-ignore
            startWith(''), 
            // @ts-ignore
            map(option => this._filterGroup(option)));
        }
        else {
            this.filteredStates = this.control.valueChanges.pipe(
            // @ts-ignore
            startWith(''), 
            // @ts-ignore
            map(option => this._filterStates(option)));
        }
        // console.log(this.options);
        // console.log(this.config);
    }
    _filterStates(value) {
        // console.log('options', this.options);
        // console.log('options', this.options.length);
        const filterValue = value.toLowerCase();
        return this.options.filter(option => option.toLowerCase().indexOf(filterValue) > -1);
    }
    _filterGroup(value) {
        // console.log(this.filteredStates);
        // console.log(this.options);
        if (value && this.options[0].name) {
            return this.options
                .map((group) => ({
                name: group.name,
                children: _filter(group.children, value, this.ts)
            }))
                .filter((group) => group.name.length > 0);
        }
        // console.log(this.options);
        return this.options;
    }
}
AutocompleteComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: AutocompleteComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
AutocompleteComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: AutocompleteComponent, selector: "app-autocomplete", inputs: { options: "options", config: "config" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <input\n      matInput\n      [placeholder]=\"getName() + '#label' | translate\"\n      [formControlName]=\"name\"\n      type=\"search\"\n      [minlength]=\"validators.minLength\"\n      [maxlength]=\"validators.maxLength\"\n      [required]=\"validators.required\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\"\n      [value]=\"getValue()\"\n      (change)=\"change.emit({ type: name, value: $event.target.value })\"\n      [matAutocomplete]=\"auto\"\n      [autocomplete]=\"autocomplete\"/>\n    <mat-autocomplete #auto=\"matAutocomplete\">\n      <ng-container *ngIf=\"config.groupBy\">\n        <mat-optgroup\n          *ngFor=\"let group of filteredStates | async\"\n          [label]=\"group.name\">\n          <mat-option\n            *ngFor=\"let element of group.children\"\n            [value]=\"element.name\">\n            {{element.name}}\n          </mat-option>\n        </mat-optgroup>\n      </ng-container>\n      <ng-container *ngIf=\"!config.groupBy\">\n        <mat-option\n          *ngFor=\"let state of filteredStates | async\"\n          [value]=\"state\">\n          <span>{{ state }}</span>\n        </mat-option>\n      </ng-container>\n    </mat-autocomplete>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i5$2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["disableRipple"], exportAs: ["matAutocomplete"] }, { type: i6.MatOptgroup, selector: "mat-optgroup", inputs: ["disabled"], exportAs: ["matOptgroup"] }, { type: i6.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i5$2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", exportAs: ["matAutocompleteTrigger"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i1$2.MinLengthValidator, selector: "[minlength][formControlName],[minlength][formControl],[minlength][ngModel]", inputs: ["minlength"] }, { type: i1$2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe, "async": i5.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: AutocompleteComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-autocomplete', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"getName() + '#hintlabel' | translate\">\n    <input\n      matInput\n      [placeholder]=\"getName() + '#label' | translate\"\n      [formControlName]=\"name\"\n      type=\"search\"\n      [minlength]=\"validators.minLength\"\n      [maxlength]=\"validators.maxLength\"\n      [required]=\"validators.required\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\"\n      [value]=\"getValue()\"\n      (change)=\"change.emit({ type: name, value: $event.target.value })\"\n      [matAutocomplete]=\"auto\"\n      [autocomplete]=\"autocomplete\"/>\n    <mat-autocomplete #auto=\"matAutocomplete\">\n      <ng-container *ngIf=\"config.groupBy\">\n        <mat-optgroup\n          *ngFor=\"let group of filteredStates | async\"\n          [label]=\"group.name\">\n          <mat-option\n            *ngFor=\"let element of group.children\"\n            [value]=\"element.name\">\n            {{element.name}}\n          </mat-option>\n        </mat-optgroup>\n      </ng-container>\n      <ng-container *ngIf=\"!config.groupBy\">\n        <mat-option\n          *ngFor=\"let state of filteredStates | async\"\n          [value]=\"state\">\n          <span>{{ state }}</span>\n        </mat-option>\n      </ng-container>\n    </mat-autocomplete>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{ hint }}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { options: [{
                type: Input
            }], config: [{
                type: Input
            }] } });

class CheckboxComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.position = 'before';
        this.allComplete = false;
    }
    updateAllComplete() {
        this.allComplete = this.options.subtasks != null && this.options.subtasks.every(t => t.completed);
    }
    someComplete() {
        if (this.options.subtasks == null) {
            return false;
        }
        return this.options.subtasks.filter(t => t.completed).length > 0 && !this.allComplete;
    }
    setAll(completed) {
        this.allComplete = completed;
        if (this.options.subtasks == null) {
            return;
        }
        this.options.subtasks.forEach(t => (t.completed = completed));
    }
    ngOnInit() {
        super.ngOnInit();
    }
}
CheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CheckboxComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
CheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: CheckboxComponent, selector: "app-checkbox", inputs: { position: "position", options: "options" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n    <div>\n      <mat-checkbox\n        [value]=\"value\"\n        [labelPosition]=\"position\"\n        [formControlName]=\"name\"\n        (change)=\"change.emit({ type: name, value: $event.checked })\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-checkbox>\n    </div>\n</ng-container>\n\n<!--div *ngIf=\"task.options\">\n  <mat-checkbox\n    [checked]=\"allComplete\"\n    [color]=\"task.color\"\n    [indeterminate]=\"someComplete()\"\n    (change)=\"setAll($event.checked)\"\n    [labelPosition]=\"position\"\n    (change)=\"change.emit({ type: name, value: $event.checked })\"\n    [disabled]=\"disabled\"\n    [matTooltip]=\"getName() + '#tooltip' | translate\"\n    matTooltipDisabled=\"false\"\n    matTooltipHideDelay=\"200\"\n    matTooltipPosition=\"above\"\n    matTooltipShowDelay=\"100\">\n    {{ getName() + \"#label\" | translate }}\n  </mat-checkbox>\n  <ul>\n    <li *ngFor=\"let subtask of task.options\">\n      <mat-checkbox\n        [(ngModel)]=\"subtask.completed\"\n        [color]=\"subtask.color\"\n        (ngModelChange)=\"updateAllComplete()\"\n      >\n        {{ subtask.name }}\n      </mat-checkbox>\n    </li>\n  </ul>\n</div-->\n", styles: [""], components: [{ type: i4$2.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-checkbox', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n    <div>\n      <mat-checkbox\n        [value]=\"value\"\n        [labelPosition]=\"position\"\n        [formControlName]=\"name\"\n        (change)=\"change.emit({ type: name, value: $event.checked })\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-checkbox>\n    </div>\n</ng-container>\n\n<!--div *ngIf=\"task.options\">\n  <mat-checkbox\n    [checked]=\"allComplete\"\n    [color]=\"task.color\"\n    [indeterminate]=\"someComplete()\"\n    (change)=\"setAll($event.checked)\"\n    [labelPosition]=\"position\"\n    (change)=\"change.emit({ type: name, value: $event.checked })\"\n    [disabled]=\"disabled\"\n    [matTooltip]=\"getName() + '#tooltip' | translate\"\n    matTooltipDisabled=\"false\"\n    matTooltipHideDelay=\"200\"\n    matTooltipPosition=\"above\"\n    matTooltipShowDelay=\"100\">\n    {{ getName() + \"#label\" | translate }}\n  </mat-checkbox>\n  <ul>\n    <li *ngFor=\"let subtask of task.options\">\n      <mat-checkbox\n        [(ngModel)]=\"subtask.completed\"\n        [color]=\"subtask.color\"\n        (ngModelChange)=\"updateAllComplete()\"\n      >\n        {{ subtask.name }}\n      </mat-checkbox>\n    </li>\n  </ul>\n</div-->\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { position: [{
                type: Input
            }], options: [{
                type: Input
            }] } });

class RadiobuttonComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        this.options = this.fs.getConfigByName(this.name).options ? this.fs.getConfigByName(this.name).options : this.options;
        // console.log(this.options);
        // console.log(this.form);
    }
}
RadiobuttonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: RadiobuttonComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
RadiobuttonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: RadiobuttonComponent, selector: "app-radiobutton", inputs: { options: "options" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <label>{{ getName()+'#label' | translate }}</label>\n    <mat-radio-group\n      [formControlName]=\"name\"\n      [matTooltip]=\"getName()+'#tooltip' | translate\"\n      [required]=\"required\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\"\n      [value]=\"value\"\n      (selectionChange)=\"change.emit({type: name, value: $event.value})\">\n    <div *ngIf=\"options && options[0].key\" class=\"radio-group-row\">\n      <mat-radio-button *ngFor=\"let item of options\" [matTooltip]=\"item.description | translate\" [value]=\"item.value\">\n        {{item.key | translate}}\n      </mat-radio-button>\n    </div>\n    </mat-radio-group>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{getName()+'#hintlabel' | translate}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n</ng-container>\n", styles: [".radio-group-row{margin-top:5px}\n"], components: [{ type: i4$3.MatRadioButton, selector: "mat-radio-button", inputs: ["disableRipple", "tabIndex"], exportAs: ["matRadioButton"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i4$3.MatRadioGroup, selector: "mat-radio-group", exportAs: ["matRadioGroup"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: RadiobuttonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-radiobutton', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <label>{{ getName()+'#label' | translate }}</label>\n    <mat-radio-group\n      [formControlName]=\"name\"\n      [matTooltip]=\"getName()+'#tooltip' | translate\"\n      [required]=\"required\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\"\n      [value]=\"value\"\n      (selectionChange)=\"change.emit({type: name, value: $event.value})\">\n    <div *ngIf=\"options && options[0].key\" class=\"radio-group-row\">\n      <mat-radio-button *ngFor=\"let item of options\" [matTooltip]=\"item.description | translate\" [value]=\"item.value\">\n        {{item.key | translate}}\n      </mat-radio-button>\n    </div>\n    </mat-radio-group>\n    <mat-hint *ngIf=\"hint\" align=\"end\">{{getName()+'#hintlabel' | translate}}</mat-hint>\n    <mat-error>\n      {{ getErrorMeesage() }}\n    </mat-error>\n</ng-container>\n", styles: [".radio-group-row{margin-top:5px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { options: [{
                type: Input
            }] } });

class SliderComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        if (!this.config && this.field.config) {
            // console.log(this.field.config);
            this.config = this.field.config;
        }
    }
    getTickIntervall() {
        if (this.config.showTicks) {
            return this.config.tickInterval > 0 ? this.config.tickInterval : 'auto';
        }
        return 0;
    }
}
SliderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SliderComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
SliderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: SliderComponent, selector: "app-slider", inputs: { config: "config" }, usesInheritance: true, ngImport: i0, template: "<ng-container [formGroup]=\"form\">\n    <mat-slider\n      [disabled]=\"disabled\"\n      [invert]=\"config.inverted\"\n      [max]=\"max\"\n      [min]=\"min\"\n      [step]=\"config.step\"\n      [thumbLabel]=\"config.showThumb\"\n      [tickInterval]=\"getTickIntervall()\"\n      [formControlName]=\"name\"\n      [vertical]=\"config.vertical\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\">\n    </mat-slider>\n    <mat-hint>{{name+'#label' | translate}}</mat-hint>\n</ng-container>\n", styles: ["mat-slider{width:100%;max-width:auto}\n"], components: [{ type: i4$4.MatSlider, selector: "mat-slider", inputs: ["disabled", "color", "tabIndex", "invert", "max", "min", "step", "thumbLabel", "tickInterval", "value", "displayWith", "valueText", "vertical"], outputs: ["change", "input", "valueChange"], exportAs: ["matSlider"] }], directives: [{ type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SliderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-slider', template: "<ng-container [formGroup]=\"form\">\n    <mat-slider\n      [disabled]=\"disabled\"\n      [invert]=\"config.inverted\"\n      [max]=\"max\"\n      [min]=\"min\"\n      [step]=\"config.step\"\n      [thumbLabel]=\"config.showThumb\"\n      [tickInterval]=\"getTickIntervall()\"\n      [formControlName]=\"name\"\n      [vertical]=\"config.vertical\"\n      [matTooltip]=\"getName() + '#tooltip' | translate\"\n      matTooltipDisabled=\"false\"\n      matTooltipHideDelay=\"200\"\n      matTooltipPosition=\"above\"\n      matTooltipShowDelay=\"100\">\n    </mat-slider>\n    <mat-hint>{{name+'#label' | translate}}</mat-hint>\n</ng-container>\n", styles: ["mat-slider{width:100%;max-width:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { config: [{
                type: Input
            }] } });

class DataFlattnerService {
    constructor() {
    }
    static isFlat(object) {
        if (!(typeof object === 'object')) {
            return false;
        }
        return true;
    }
    /** isBuffer
     * used for flatten unflatten
     * @obj
     */
    static isBuffer(obj) {
        return obj != null && obj.constructor != null &&
            typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj);
    }
    static flatten(target, opts) {
        opts = opts || {};
        const delimiter = opts.delimiter || '.';
        const maxDepth = opts.maxDepth;
        const output = {};
        function step(object, prev, currentDepth) {
            currentDepth = currentDepth || 1;
            Object.keys(object).forEach((key) => {
                const value = object[key];
                const isArray = opts.safe && Array.isArray(value);
                const type = Object.prototype.toString.call(value);
                const isBuffer = DataFlattnerService.isBuffer(value);
                const isObject = (type === '[object Object]' ||
                    type === '[object Array]');
                const newKey = prev ? prev + delimiter + key : key;
                if (!isArray && !isBuffer && isObject && Object.keys(value).length &&
                    (!opts.maxDepth || currentDepth < maxDepth)) {
                    return step(value, newKey, currentDepth + 1);
                }
                output[newKey] = value;
            });
        }
        step(target);
        return output;
    }
    static unflatten(target, opts) {
        opts = opts || {};
        const delimiter = opts.delimiter || '.';
        const overwrite = opts.overwrite;
        const result = {};
        const isBuffer = DataFlattnerService.isBuffer(target);
        if (isBuffer || Object.prototype.toString.call(target) !== '[object Object]') {
            return target;
        }
        function getKey(key) {
            const parsedKey = key;
            return (isNaN(parsedKey) ||
                key.indexOf('.') !== -1 ||
                opts.object) ? key : parsedKey;
        }
        const sortKeys = Object.keys(target).sort((keyA, keyB) => {
            return keyA.length - keyB.length;
        });
        sortKeys.forEach((key) => {
            const split = key.split(delimiter);
            let key1 = getKey(split.shift());
            let key2 = getKey(split[0]);
            let recipient = result;
            while (key2 !== undefined) {
                const type = Object.prototype.toString.call(recipient[key1]);
                const isObject = (type === '[object Object]' ||
                    type === '[object Array]');
                if (!overwrite && !isObject && typeof recipient[key1] !== 'undefined') {
                    return;
                }
                if ((overwrite && !isObject) || (!overwrite && recipient[key1] == null)) {
                    recipient[key1] = (typeof key2 === 'number' &&
                        !opts.object ? [] : {});
                }
                recipient = recipient[key1];
                if (split.length > 0) {
                    key1 = getKey(split.shift());
                    key2 = getKey(split[0]);
                }
            }
            recipient[key1] = DataFlattnerService.unflatten(target[key], opts);
        });
        return result;
    }
}
DataFlattnerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataFlattnerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DataFlattnerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataFlattnerService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataFlattnerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class AutoSearch {
}

class ConfigService {
    constructor(http) {
        this.http = http;
        this.dataChange = new BehaviorSubject([]);
        this.emptyObj = {
            name: 'home_ui_new'
        };
        this.flatControlls = [];
        // console.log(this.flatControlls);
    }
    buildTree(config) {
        // console.log(config);
        const entries = [];
        for (const page in config) {
            if (page) {
                for (const formN in config[page]) {
                    if (config[page][formN]) {
                        const subLvl = [];
                        const form = config[page][formN];
                        // console.log(form);
                        for (const [key, value] of Object.entries(form)) {
                            // console.log(`${key}: ${value}`);
                            subLvl.push(value.name);
                            // children.push(value.name);
                        }
                        const tmpData = [
                            {
                                name: formN,
                                children: subLvl
                            }
                        ];
                        entries.push(tmpData);
                    }
                }
            }
        }
        // DataFlattnerService.flatten(tmpData)
        // this.flatControlls = tmpData;
        // console.log("newtree", this.flatControlls);
    }
    get data() {
        return this.dataChange.value;
    }
    /**
     * Build the file structure tree. The `value` is the Json object, or a sub-tree of a Json object.
     * The return value is the list of `AutoSearch`.
     */
    buildFileTree(obj, level) {
        return Object.keys(obj).reduce((accumulator, key) => {
            const value = obj[key];
            // console.log(value);
            const node = new AutoSearch();
            node.name = key;
            if (value != null) {
                if (typeof value === 'object' && level < 2) {
                    node.children = this.buildFileTree(value, level + 1);
                }
                else {
                    if (level === 2) {
                        node.name = value.name;
                    }
                    else {
                        node.name = value;
                    }
                }
            }
            const data = accumulator.concat(node);
            this.dataChange.next(data);
            return accumulator.concat(node);
        }, []);
    }
    getControlls() {
        return this.flatControlls;
    }
    getFlatControlls() {
        return DataFlattnerService.flatten(this.flatControlls);
    }
    getConfigByName(name) {
        const keys = name.split('_');
        const page = keys[0];
        const form = keys[1];
        const key = keys[2];
        if (this.configs[page] && this.configs[page][form]) {
            return this.configs[page][form][key]
                ? this.configs[page][form][key]
                : this.emptyObj;
        }
        else {
            return this.emptyObj;
        }
    }
    getAppConfigs(appData) {
        let data = {};
        Object.keys(appData).forEach(page => {
            const formObj = appData[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (this.configs[page] && this.configs[page][form] && this.configs[page][form][key]) {
                            // data[page][form][key] = field;
                            merge(data, { [page]: { [form]: { [key]: field } } });
                        }
                    });
                });
            }
        });
        return data;
    }
    getFBConfig(appData) {
        let data = {};
        Object.keys(appData).forEach(page => {
            const formObj = appData[page];
            if (formObj) {
                Object.keys(formObj).forEach(form => {
                    const forM = formObj[form];
                    Object.keys(forM).forEach(key => {
                        const field = forM[key];
                        if (!this.configs[page] || !this.configs[page][form] || !this.configs[page][form][key]) {
                            // data[page][form][key] = field;
                            merge(data, { [page]: { [form]: { [key]: field } } });
                        }
                    });
                });
            }
        });
        return data;
    }
}
ConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ConfigService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
ConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; } });

class CsvConfigConsts {
}
CsvConfigConsts.EOL = '\r\n';
CsvConfigConsts.BOM = '\ufeff';
CsvConfigConsts.DEFAULT_FIELD_SEPARATOR = ',';
CsvConfigConsts.DEFAULT_DECIMAL_SEPARATOR = '.';
CsvConfigConsts.DEFAULT_QUOTE = '"';
CsvConfigConsts.DEFAULT_SHOW_TITLE = false;
CsvConfigConsts.DEFAULT_TITLE = 'My Report';
CsvConfigConsts.DEFAULT_FILENAME = 'mycsv.csv';
CsvConfigConsts.DEFAULT_SHOW_LABELS = false;
CsvConfigConsts.DEFAULT_USE_BOM = true;
CsvConfigConsts.DEFAULT_HEADER = [];
CsvConfigConsts.DEFAULT_OBJ_HEADER = {};
CsvConfigConsts.DEFAULT_USE_OBJ_HEADER = false;
CsvConfigConsts.DEFAULT_USE_HEADER = false;
CsvConfigConsts.DEFAULT_NO_DOWNLOAD = false;
CsvConfigConsts.DEFAULT_NULL_TO_EMPTY_STRING = false;
const ConfigDefaults = {
    filename: CsvConfigConsts.DEFAULT_FILENAME,
    fieldSeparator: CsvConfigConsts.DEFAULT_FIELD_SEPARATOR,
    quoteStrings: CsvConfigConsts.DEFAULT_QUOTE,
    decimalseparator: CsvConfigConsts.DEFAULT_DECIMAL_SEPARATOR,
    showLabels: CsvConfigConsts.DEFAULT_SHOW_LABELS,
    showTitle: CsvConfigConsts.DEFAULT_SHOW_TITLE,
    title: CsvConfigConsts.DEFAULT_TITLE,
    useBom: CsvConfigConsts.DEFAULT_USE_BOM,
    headers: CsvConfigConsts.DEFAULT_HEADER,
    objHeader: CsvConfigConsts.DEFAULT_OBJ_HEADER,
    useObjHeader: CsvConfigConsts.DEFAULT_USE_OBJ_HEADER,
    useHeader: CsvConfigConsts.DEFAULT_USE_HEADER,
    noDownload: CsvConfigConsts.DEFAULT_NO_DOWNLOAD,
    nullToEmptyString: CsvConfigConsts.DEFAULT_NULL_TO_EMPTY_STRING
};
class AngularCsv {
    constructor(DataJSON, filename, options) {
        this.csv = '';
        let config = options || {};
        this.data = typeof DataJSON !== 'object' ? JSON.parse(DataJSON) : DataJSON;
        this._options = objectAssign({}, ConfigDefaults, config);
        if (this._options.filename) {
            this._options.filename = filename;
        }
        this.generateCsv();
    }
    /**
     * Check if is Float
     * @param input: any
     */
    static isFloat(input) {
        return +input === input && (!isFinite(input) || Boolean(input % 1));
    }
    /**
     * Generate and Download Csv
     */
    generateCsv() {
        if (this._options.useBom) {
            this.csv += CsvConfigConsts.BOM;
        }
        if (this._options.showTitle) {
            this.csv += this._options.title + '\r\n\n';
        }
        if (this._options.useObjHeader &&
            Object.keys(this._options.objHeader).length > 0) {
            this.getHeaderFromObj();
            this.getBodyAccordingHeader();
        }
        else {
            this.getHeaders();
            this.getBody();
        }
        if (this.csv === '') {
            console.log('Invalid data');
            return '';
        }
        if (this._options.noDownload) {
            return this.csv;
        }
        let blob = new Blob([this.csv], { type: 'text/csv;charset=utf8;' });
        if (navigator.msSaveBlob) {
            let filename = this._options.filename.replace(/ /g, '_') + '.csv';
            navigator.msSaveBlob(blob, filename);
        }
        else {
            let uri = 'data:attachment/csv;charset=utf-8,' + encodeURI(this.csv);
            let link = document.createElement('a');
            link.href = URL.createObjectURL(blob);
            link.setAttribute('target', '_blank');
            link.setAttribute('visibility', 'hidden');
            link.download = this._options.filename.replace(/ /g, '_') + '.csv';
            document.body.appendChild(link);
            link.click();
            document.body.removeChild(link);
        }
        return '';
    }
    /**
     * Create Headers
     */
    getHeaders() {
        if (this._options.headers.length > 0) {
            const { headers } = this._options;
            let row = headers.reduce((headerRow, header) => {
                return headerRow + header + this._options.fieldSeparator;
            }, '');
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Header from Object
     */
    getHeaderFromObj() {
        if (Object.keys(this._options.objHeader).length > 0) {
            let row = '';
            Object.keys(this._options.objHeader).forEach(key => {
                row += this._options.objHeader[key] + this._options.fieldSeparator;
            });
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Body according to obj header
     */
    getBodyAccordingHeader() {
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            let row = '';
            if (this._options.useObjHeader &&
                Object.keys(this._options.objHeader).length > 0) {
                Object.keys(this._options.objHeader).forEach(key => {
                    row +=
                        this.formatData(this.data[i][key]) + this._options.fieldSeparator;
                });
            }
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Create Body
     */
    getBody() {
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            let row = '';
            if (this._options.useHeader && this._options.headers.length > 0) {
                for (const index of this._options.headers) {
                    row +=
                        this.formatData(this.data[i][index]) + this._options.fieldSeparator;
                }
            }
            else {
                for (const index in this.data[i]) {
                    if (this.data[i][index]) {
                        row +=
                            this.formatData(this.data[i][index]) +
                                this._options.fieldSeparator;
                    }
                }
            }
            row = row.slice(0, -1);
            this.csv += row + CsvConfigConsts.EOL;
        }
    }
    /**
     * Format Data
     * @param data: any
     */
    formatData(data) {
        if (this._options.decimalseparator === 'locale' &&
            AngularCsv.isFloat(data)) {
            return data.toLocaleString();
        }
        if (this._options.decimalseparator !== '.' && AngularCsv.isFloat(data)) {
            return data.toString().replace('.', this._options.decimalseparator);
        }
        if (typeof data === 'string') {
            data = data.replace(/"/g, '""');
            if (this._options.quoteStrings ||
                data.indexOf(',') > -1 ||
                data.indexOf('\n') > -1 ||
                data.indexOf('\r') > -1) {
                data = this._options.quoteStrings + data + this._options.quoteStrings;
            }
            return data;
        }
        if (this._options.nullToEmptyString) {
            if (!data) {
                return (data = '');
            }
            else {
                return data;
            }
        }
        if (typeof data === 'boolean') {
            return data ? 'TRUE' : 'FALSE';
        }
        return data;
    }
    getCsvData() {
        return this.csv;
    }
}
let hasOwnProperty = Object.prototype.hasOwnProperty;
let propIsEnumerable = Object.prototype.propertyIsEnumerable;
/**
 * Convet to Object
 * @param val:any
 */
function toObject(val) {
    if (val === null || val === undefined) {
        throw new TypeError('Object.assign cannot be called with null or undefined');
    }
    return Object(val);
}
/**
 * Assign data  to new Object
 * @param  target: any
 * @param  source: any[]
 */
function objectAssign(target, ...source) {
    let from;
    let to = toObject(target);
    let symbols;
    for (let s = 1; s < arguments.length; s++) {
        from = Object(arguments[s]);
        for (const key in from) {
            if (hasOwnProperty.call(from, key)) {
                to[key] = from[key];
            }
        }
        if (Object.getOwnPropertySymbols) {
            symbols = Object.getOwnPropertySymbols(from);
            // tslint:disable-next-line: prefer-for-of
            for (let i = 0; i < symbols.length; i++) {
                if (propIsEnumerable.call(from, symbols[i])) {
                    to[symbols[i]] = from[symbols[i]];
                }
            }
        }
    }
    return to;
}

var TableType;
(function (TableType) {
    TableType["USER"] = "USER";
    TableType["FILE"] = "FILE";
    TableType["GENERIC"] = "GENERIC";
})(TableType || (TableType = {}));
// TODO: A structure that helps generation the table
// TODO: Make the action buttons configurable. Eg.: disabled
// TODO: add for CodeTables an entry in getDisplayRepresentation()
class TableComponent {
    constructor(dialog, ts) {
        this.dialog = dialog;
        this.ts = ts;
        this.selection = new SelectionModel(true, []);
        this.collumnsToBeDisplayed = [];
        this.initialColumns = [];
        this.dataSource = new MatTableDataSource();
        this.resultsLength = 0;
        this.filterControl = new FormControl('');
        this.displayedColumns = [];
        this.data = [];
        this.edit = new EventEmitter();
        this.download = new EventEmitter();
        this.delete = new EventEmitter();
        this.deleteBulk = new EventEmitter();
    }
    applyFilter(filterValue) {
        this.dataSource.filter = event.target.value;
        this.selection.clear();
    }
    /** Whether the number of selected elements matches the total number of rows. */
    isAllSelected() {
        const numSelected = this.selection.selected.length;
        const numRows = this.dataSource.filteredData.length;
        return numSelected === numRows;
    }
    /** Selects all rows if they are not all selected; otherwise clear selection. */
    masterToggle() {
        this.isAllSelected() ?
            this.selection.clear() :
            this.dataSource.filteredData.forEach(row => this.selection.select(row));
    }
    ngOnInit() {
        this.dataSource.data = this.data || [];
        if (this.viewOptions.showDeleteAllButton !== false) {
            this.viewOptions.showDeleteAllButton = true;
        }
        if (this.viewOptions.showCheckbox) {
            this.displayedColumns.unshift({ collumnName: 'select' });
        }
        if (this.viewOptions.showActions) {
            this.displayedColumns.push({ collumnName: 'actions' });
        }
        this.collumnsToBeDisplayed = this.displayedColumns.map(header => header.collumnName);
        this.initialColumns = this.displayedColumns.filter((column) => column.collumnName !== '')
            .map((column) => column.collumnName);
        this.dataSource.filterPredicate = (data, filter) => this.customFilterBasedOnDisplayColumns(data, filter);
    }
    ngAfterViewInit() {
        this.dataSource.paginator = this.paginator;
        this.dataSource.sort = this.sort;
        if (this.viewOptions.dateStringToDateFilter) {
            this.dataSource.sortingDataAccessor = (item, property) => {
                switch (property) {
                    case this.viewOptions.dateStringToDateFilter:
                        {
                            return moment(item[property], 'L', 'de', true).unix();
                        }
                        ;
                    default: return item[property];
                }
            };
        }
    }
    ngOnChanges(changes) {
        this.selection.clear();
        if (changes['data']) {
            this.data = changes.data.currentValue || [];
            this.dataSource.data = this.data;
            this.resultsLength = this.data.length;
            this.dataSource.filter = '';
            this.filterControl.patchValue('');
            if (this.paginator) {
                this.dataSource.paginator.firstPage();
            }
        }
    }
    onEdit(row) {
        this.edit.emit(row);
    }
    onDownload(row) {
        this.download.emit(row);
    }
    onDeleteRecord(row) {
        this.delete.emit(row);
        this.selection.clear();
    }
    onDeleteSelectedRecords() {
        const filteredDatasource = this.dataSource.filteredData.filter(item => this.selection.selected.indexOf(item) >= 0);
        this.deleteBulk.emit(filteredDatasource);
        this.selection.clear();
    }
    customFilterBasedOnDisplayColumns(data, filter) {
        for (const columnName of this.initialColumns) {
            // console.log(data);
            // console.log(columnName);
            if (data[columnName] && data[columnName].toString().trim().toLowerCase().indexOf(filter.toLowerCase()) >= 0) {
                return true;
            }
        }
        return false;
    }
    getDisplayData(colums) {
        const result = [];
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.data.length; i++) {
            const row = {};
            // tslint:disable-next-line: prefer-for-of
            for (let y = 0; y < colums.length; y++) {
                row[colums[y].collumnName] = this.data[i][colums[y].collumnName] ? this.data[i][colums[y].collumnName] : ' ';
            }
            // console.log('row', row);
            result.push(row);
        }
        // console.log('result', result);
        return result;
    }
    getFilteredDisplayData(colums) {
        const result = [];
        // tslint:disable-next-line: prefer-for-of
        for (let i = 0; i < this.dataSource.filteredData.length; i++) {
            const row = {};
            // tslint:disable-next-line: prefer-for-of
            for (let y = 0; y < colums.length; y++) {
                row[colums[y].collumnName] = this.dataSource.filteredData[i][colums[y].collumnName];
            }
            // console.log('row', row);
            result.push(row);
        }
        // console.log('result', result);
        return result;
    }
    refresh() {
        this.dataSource.data = this.data;
    }
    csvExport() {
        let columns = Object.assign([], this.displayedColumns);
        let columnNames = Object.assign([], this.displayedColumns.map(header => header.collumnKey ?
            this.ts.transform(header.collumnKey) : header.collumnName));
        columns = columns.filter((el) => {
            return el.collumnName !== '' && el.collumnName !== 'select' && el.collumnName !== 'actions';
        });
        columnNames = columnNames.filter((el) => {
            return el !== '' && el !== 'select' && el !== 'actions';
        });
        const tmpData = this.getDisplayData(columns);
        const name = this.viewOptions.csvName ? this.viewOptions.csvName : 'Formbuilder';
        const options = {
            fieldSeparator: ';',
            quoteStrings: '"',
            decimalseparator: '.',
            showLabels: true,
            showTitle: false,
            title: name,
            useBom: true,
            noDownload: false,
            headers: columnNames
        };
        // console.log(columns);
        const file = new AngularCsv(tmpData, name, options);
        // console.log('csv', file);
    }
}
TableComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TableComponent, deps: [{ token: i1$1.MatDialog }, { token: TranslatePipe }], target: i0.ɵɵFactoryTarget.Component });
TableComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: TableComponent, selector: "app-table", inputs: { displayedColumns: "displayedColumns", viewOptions: "viewOptions", data: "data" }, outputs: { dataSource: "dataSource", edit: "edit", download: "download", delete: "delete", deleteBulk: "deleteBulk" }, viewQueries: [{ propertyName: "paginator", first: true, predicate: MatPaginator, descendants: true }, { propertyName: "sort", first: true, predicate: MatSort, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<ng-container *ngIf=\"viewOptions.searchable\">\n  <mat-form-field\n    [ngClass]=\"viewOptions.showCSVExport ? 'short-filter' : 'long-filter'\">\n    <input\n      matInput\n      [formControl]=\"filterControl\"\n      (keyup)=\"applyFilter($event.target.value)\"\n      placeholder=\"Filter\"\n      autocomplete=\"off\"\n      maxlength=\"250\"\n    />\n  </mat-form-field>\n</ng-container>\n<div class=\"row\">\n  <button\n    *ngIf=\"viewOptions.showCSVExport\"\n    mat-icon-button\n    (click)=\"csvExport()\"\n    id=\"table-export\">\n    <mat-icon>vertical_align_bottom</mat-icon>\n  </button>\n  <mat-paginator\n    *ngIf=\"viewOptions.showPaginator\"\n    [pageSizeOptions]=\"[5, 25, 50]\"\n    [length]=\"resultsLength\"\n    [pageSize]=\"5\"\n    showFirstLastButtons>\n  </mat-paginator>\n</div>\n<table mat-table [dataSource]=\"dataSource\" matSort class=\"mat-elevation-z8\">\n  <ng-container *ngFor=\"let collumn of displayedColumns\">\n    <ng-container\n      *ngIf=\"\n        collumn.collumnName !== 'select' &&\n        collumn.collumnName !== 'actions' &&\n        displayedColumns\"\n      [matColumnDef]=\"collumn.collumnName\"\n      >\n      <th\n        mat-header-cell\n        *matHeaderCellDef\n        mat-sort-header\n        [ngStyle]=\"{\n          'width.%': collumn.widthInPercentage\n            ? collumn.widthInPercentage\n            : 'auto'\n        }\">\n        {{ collumn.collumnKey? (collumn.collumnKey | translate) : collumn.collumnName }}\n      </th>\n      <td mat-cell *matCellDef=\"let element\">\n        {{ element[collumn.collumnName] }}\n      </td>\n    </ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showCheckbox\" matColumnDef=\"select\">\n    <th mat-header-cell *matHeaderCellDef>\n      <mat-checkbox\n        (change)=\"$event ? masterToggle() : null\"\n        [checked]=\"selection.hasValue() && isAllSelected()\"\n        [indeterminate]=\"selection.hasValue() && !isAllSelected()\">\n      </mat-checkbox>\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <mat-checkbox\n        (click)=\"$event.stopPropagation()\"\n        (change)=\"$event ? selection.toggle(row) : null\"\n        [checked]=\"selection.isSelected(row)\">\n      </mat-checkbox>\n    </td>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showActions\" matColumnDef=\"actions\">\n    <th mat-header-cell *matHeaderCellDef></th>\n    <td mat-cell *matCellDef=\"let row\" (click)=\"$event.stopPropagation()\">\n      <button\n        mat-icon-button\n        (click)=\"onDeleteRecord(row)\"\n        style=\"float: right;\">\n        <mat-icon>delete_forever</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type !== 'FILE'\"\n        mat-icon-button\n        (click)=\"onEdit(row)\"\n        style=\"float: right;\">\n        <mat-icon>edit</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type === 'FILE'\"\n        mat-icon-button\n        (click)=\"onDownload(row)\"\n        style=\"float: right;\">\n        <mat-icon>get_app</mat-icon>\n      </button>\n    </td>\n  </ng-container>\n\n  <tr\n    mat-header-row\n    *matHeaderRowDef=\"collumnsToBeDisplayed; sticky: true\"></tr>\n  <tr\n    mat-row\n    *matRowDef=\"let row; columns: collumnsToBeDisplayed\"\n    (click)=\"selection.toggle(row)\"></tr>\n</table>\n\n<div class=\"flex flex-end table-action\" *ngIf=\"viewOptions.showCheckbox\">\n  <button\n    style=\"width: 165px; margin-right: 20px; white-space: normal; line-height: normal;\"\n    *ngIf=\"viewOptions.type === 'FILE'\"\n    mat-raised-button\n    color=\"primary\">\n    File Upload\n  </button>\n\n  <!--Delete All Selected-->\n  <button\n    *ngIf=\"viewOptions.showCheckbox && viewOptions.showDeleteAllButton\"\n    style=\"width: 165px;\"\n    mat-raised-button\n    color=\"primary\"\n    [disabled]=\"selection.isEmpty()\"\n    (click)=\"onDeleteSelectedRecords()\">\n    L\u00F6schen\n  </button>\n</div>\n", styles: ["table{width:100%}.row{display:flex;flex-direction:row-reverse;margin-bottom:5px}.long-filter{float:left;width:calc(100% - 520px)!important}.short-filter{float:left;width:calc(100% - 560px)!important}#table-export{float:right;margin-top:8px}.mat-column-actions{width:104px!important;white-space:unset!important}.mat-column-select{width:50px!important}\n"], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i4.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i6$2.MatPaginator, selector: "mat-paginator", inputs: ["disabled"], exportAs: ["matPaginator"] }, { type: i7.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { type: i8$1.MatSortHeader, selector: "[mat-sort-header]", inputs: ["disabled", "mat-sort-header", "arrowPosition", "start", "sortActionDescription", "disableClear"], exportAs: ["matSortHeader"] }, { type: i4$2.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }, { type: i7.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { type: i7.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i1$2.MaxLengthValidator, selector: "[maxlength][formControlName],[maxlength][formControl],[maxlength][ngModel]", inputs: ["maxlength"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i8$1.MatSort, selector: "[matSort]", inputs: ["matSortDisabled", "matSortActive", "matSortStart", "matSortDirection", "matSortDisableClear"], outputs: ["matSortChange"], exportAs: ["matSort"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i7.MatColumnDef, selector: "[matColumnDef]", inputs: ["sticky", "matColumnDef"] }, { type: i7.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { type: i7.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { type: i5.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i7.MatCellDef, selector: "[matCellDef]" }, { type: i7.MatCell, selector: "mat-cell, td[mat-cell]" }, { type: i7.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { type: i7.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: TableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-table', template: "<ng-container *ngIf=\"viewOptions.searchable\">\n  <mat-form-field\n    [ngClass]=\"viewOptions.showCSVExport ? 'short-filter' : 'long-filter'\">\n    <input\n      matInput\n      [formControl]=\"filterControl\"\n      (keyup)=\"applyFilter($event.target.value)\"\n      placeholder=\"Filter\"\n      autocomplete=\"off\"\n      maxlength=\"250\"\n    />\n  </mat-form-field>\n</ng-container>\n<div class=\"row\">\n  <button\n    *ngIf=\"viewOptions.showCSVExport\"\n    mat-icon-button\n    (click)=\"csvExport()\"\n    id=\"table-export\">\n    <mat-icon>vertical_align_bottom</mat-icon>\n  </button>\n  <mat-paginator\n    *ngIf=\"viewOptions.showPaginator\"\n    [pageSizeOptions]=\"[5, 25, 50]\"\n    [length]=\"resultsLength\"\n    [pageSize]=\"5\"\n    showFirstLastButtons>\n  </mat-paginator>\n</div>\n<table mat-table [dataSource]=\"dataSource\" matSort class=\"mat-elevation-z8\">\n  <ng-container *ngFor=\"let collumn of displayedColumns\">\n    <ng-container\n      *ngIf=\"\n        collumn.collumnName !== 'select' &&\n        collumn.collumnName !== 'actions' &&\n        displayedColumns\"\n      [matColumnDef]=\"collumn.collumnName\"\n      >\n      <th\n        mat-header-cell\n        *matHeaderCellDef\n        mat-sort-header\n        [ngStyle]=\"{\n          'width.%': collumn.widthInPercentage\n            ? collumn.widthInPercentage\n            : 'auto'\n        }\">\n        {{ collumn.collumnKey? (collumn.collumnKey | translate) : collumn.collumnName }}\n      </th>\n      <td mat-cell *matCellDef=\"let element\">\n        {{ element[collumn.collumnName] }}\n      </td>\n    </ng-container>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showCheckbox\" matColumnDef=\"select\">\n    <th mat-header-cell *matHeaderCellDef>\n      <mat-checkbox\n        (change)=\"$event ? masterToggle() : null\"\n        [checked]=\"selection.hasValue() && isAllSelected()\"\n        [indeterminate]=\"selection.hasValue() && !isAllSelected()\">\n      </mat-checkbox>\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <mat-checkbox\n        (click)=\"$event.stopPropagation()\"\n        (change)=\"$event ? selection.toggle(row) : null\"\n        [checked]=\"selection.isSelected(row)\">\n      </mat-checkbox>\n    </td>\n  </ng-container>\n\n  <ng-container *ngIf=\"viewOptions.showActions\" matColumnDef=\"actions\">\n    <th mat-header-cell *matHeaderCellDef></th>\n    <td mat-cell *matCellDef=\"let row\" (click)=\"$event.stopPropagation()\">\n      <button\n        mat-icon-button\n        (click)=\"onDeleteRecord(row)\"\n        style=\"float: right;\">\n        <mat-icon>delete_forever</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type !== 'FILE'\"\n        mat-icon-button\n        (click)=\"onEdit(row)\"\n        style=\"float: right;\">\n        <mat-icon>edit</mat-icon>\n      </button>\n      <button\n        *ngIf=\"viewOptions.type === 'FILE'\"\n        mat-icon-button\n        (click)=\"onDownload(row)\"\n        style=\"float: right;\">\n        <mat-icon>get_app</mat-icon>\n      </button>\n    </td>\n  </ng-container>\n\n  <tr\n    mat-header-row\n    *matHeaderRowDef=\"collumnsToBeDisplayed; sticky: true\"></tr>\n  <tr\n    mat-row\n    *matRowDef=\"let row; columns: collumnsToBeDisplayed\"\n    (click)=\"selection.toggle(row)\"></tr>\n</table>\n\n<div class=\"flex flex-end table-action\" *ngIf=\"viewOptions.showCheckbox\">\n  <button\n    style=\"width: 165px; margin-right: 20px; white-space: normal; line-height: normal;\"\n    *ngIf=\"viewOptions.type === 'FILE'\"\n    mat-raised-button\n    color=\"primary\">\n    File Upload\n  </button>\n\n  <!--Delete All Selected-->\n  <button\n    *ngIf=\"viewOptions.showCheckbox && viewOptions.showDeleteAllButton\"\n    style=\"width: 165px;\"\n    mat-raised-button\n    color=\"primary\"\n    [disabled]=\"selection.isEmpty()\"\n    (click)=\"onDeleteSelectedRecords()\">\n    L\u00F6schen\n  </button>\n</div>\n", styles: ["table{width:100%}.row{display:flex;flex-direction:row-reverse;margin-bottom:5px}.long-filter{float:left;width:calc(100% - 520px)!important}.short-filter{float:left;width:calc(100% - 560px)!important}#table-export{float:right;margin-top:8px}.mat-column-actions{width:104px!important;white-space:unset!important}.mat-column-select{width:50px!important}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.MatDialog }, { type: TranslatePipe }]; }, propDecorators: { dataSource: [{
                type: Output
            }], displayedColumns: [{
                type: Input
            }], viewOptions: [{
                type: Input
            }], data: [{
                type: Input
            }], paginator: [{
                type: ViewChild,
                args: [MatPaginator]
            }], sort: [{
                type: ViewChild,
                args: [MatSort]
            }], edit: [{
                type: Output
            }], download: [{
                type: Output
            }], delete: [{
                type: Output
            }], deleteBulk: [{
                type: Output
            }] } });

class SlideToggleComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.options);
        // console.log(this.form);
    }
}
SlideToggleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SlideToggleComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
SlideToggleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: SlideToggleComponent, selector: "app-slidetoggle", inputs: { color: "color" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"name+'#hintlabel' | translate\">\n    <mat-slide-toggle\n          class=\"example-margin\"\n          [color]=\"color\"\n          [formControlName]=\"name\"\n          [checked]=\"value\"\n          [matTooltip]=\"getName() + '#tooltip' | translate\"\n          matTooltipDisabled=\"false\"\n          matTooltipHideDelay=\"200\"\n          matTooltipPosition=\"above\"\n          matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-slide-toggle>\n      <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n      <mat-error>\n        {{ getErrorMeesage() }}\n      </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i5$3.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["disabled", "disableRipple", "color", "tabIndex", "name", "id", "labelPosition", "aria-label", "aria-labelledby", "aria-describedby", "required", "checked"], outputs: ["change", "toggleChange"], exportAs: ["matSlideToggle"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i4$1.MatError, selector: "mat-error", inputs: ["id"] }], pipes: { "translate": TranslatePipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: SlideToggleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-slidetoggle', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field [hintLabel]=\"name+'#hintlabel' | translate\">\n    <mat-slide-toggle\n          class=\"example-margin\"\n          [color]=\"color\"\n          [formControlName]=\"name\"\n          [checked]=\"value\"\n          [matTooltip]=\"getName() + '#tooltip' | translate\"\n          matTooltipDisabled=\"false\"\n          matTooltipHideDelay=\"200\"\n          matTooltipPosition=\"above\"\n          matTooltipShowDelay=\"100\">\n        {{ getName() + \"#label\" | translate }}\n      </mat-slide-toggle>\n      <mat-hint *ngIf=\"hint\" align=\"end\">{{hint}}</mat-hint>\n      <mat-error>\n        {{ getErrorMeesage() }}\n      </mat-error>\n  </mat-form-field>\n</ng-container>\n", styles: [""] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { color: [{
                type: Input
            }] } });

class CheckBoxGroupComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.position = 'before';
        // @Input() options: CheckboxGroup;
        this.options = {
            name: 'Indeterminate',
            completed: false,
            color: 'primary',
            subtasks: [
                { name: 'Primary', completed: false, color: 'primary' },
                { name: 'Accent', completed: false, color: 'accent' },
                { name: 'Warn', completed: false, color: 'warn' },
            ],
        };
        this.allComplete = false;
    }
    updateAllComplete() {
        this.allComplete = this.options.subtasks != null && this.options.subtasks.every(t => t.completed);
    }
    someComplete() {
        if (this.options.subtasks == null) {
            return false;
        }
        return this.options.subtasks.filter(t => t.completed).length > 0 && !this.allComplete;
    }
    setAll(completed) {
        this.allComplete = completed;
        if (this.options.subtasks == null) {
            return;
        }
        this.options.subtasks.forEach(t => (t.completed = completed));
    }
    ngOnInit() {
        super.ngOnInit();
    }
}
CheckBoxGroupComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CheckBoxGroupComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
CheckBoxGroupComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: CheckBoxGroupComponent, selector: "app-check-box-group", inputs: { position: "position" }, usesInheritance: true, ngImport: i0, template: "<section class=\"example-section\">\n  <span class=\"example-list-section\">\n    <mat-checkbox class=\"example-margin\"\n                  [checked]=\"allComplete\"\n                  [color]=\"options.color\"\n                  [indeterminate]=\"someComplete()\"\n                  (change)=\"setAll($event.checked)\">\n      {{options.name}}\n    </mat-checkbox>\n  </span>\n  <span class=\"example-list-section\">\n    <ul>\n      <li *ngFor=\"let subtask of options.subtasks\">\n        <mat-checkbox [(ngModel)]=\"subtask.completed\"\n                      [color]=\"subtask.color\"\n                      (ngModelChange)=\"updateAllComplete()\">\n          {{subtask.name}}\n        </mat-checkbox>\n      </li>\n    </ul>\n  </span>\n</section>\n", styles: [".section{height:100%}.example-section{margin:12px 0}.example-margin{margin:0 12px}ul{list-style-type:none;margin-top:4px}\n"], components: [{ type: i4$2.MatCheckbox, selector: "mat-checkbox", inputs: ["disableRipple", "color", "tabIndex", "aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }], directives: [{ type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CheckBoxGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-check-box-group', template: "<section class=\"example-section\">\n  <span class=\"example-list-section\">\n    <mat-checkbox class=\"example-margin\"\n                  [checked]=\"allComplete\"\n                  [color]=\"options.color\"\n                  [indeterminate]=\"someComplete()\"\n                  (change)=\"setAll($event.checked)\">\n      {{options.name}}\n    </mat-checkbox>\n  </span>\n  <span class=\"example-list-section\">\n    <ul>\n      <li *ngFor=\"let subtask of options.subtasks\">\n        <mat-checkbox [(ngModel)]=\"subtask.completed\"\n                      [color]=\"subtask.color\"\n                      (ngModelChange)=\"updateAllComplete()\">\n          {{subtask.name}}\n        </mat-checkbox>\n      </li>\n    </ul>\n  </span>\n</section>\n", styles: [".section{height:100%}.example-section{margin:12px 0}.example-margin{margin:0 12px}ul{list-style-type:none;margin-top:4px}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { position: [{
                type: Input
            }] } });

class ChipsCompleteComponent extends BaseFieldComponent {
    constructor(fb, fs, ts) {
        super(fb, fs, ts);
        this.fb = fb;
        this.fs = fs;
        this.ts = ts;
        this.separatorKeysCodes = [ENTER, COMMA];
        this.fruitCtrl = new FormControl('', [Validators.required]);
        this.filteredFruits = of([]);
        this.fruits = [];
        this.canAdd = true;
        this.multiple = false;
        this.actualOptions = -1;
        this.active = false;
        this.options = [];
        this.config = {
            groupBy: false
        };
    }
    ngOnInit() {
        super.ngOnInit();
        // console.log(this.name);
        let config = this.fs.getConfigByName(this.name);
        this.options = config.options ? config.options : this.options;
        this.filteredFruits = of(this.options);
        this.actualOptions = this.options.length >= 0 ? 0 : -1;
        this.canAdd = config.canAdd ? config.canAdd : false;
        this.multiple = config.multiple ? config.multiple : true;
        this.active = config.selectable ? config.selectable : false;
        // console.log(this.options);
        if (config.value) {
            this.fruits = config.value.split(',');
        }
        if (this.config.groupBy) {
            this.filteredFruits = this.fruitCtrl.valueChanges.pipe(
            // @ts-ignore
            startWith(''), 
            // @ts-ignore
            map(option => this._filterGroup(option)));
        }
        else {
            this.filteredFruits = this.fruitCtrl.valueChanges.pipe(
            // @ts-ignore
            startWith(''), 
            // @ts-ignore
            map(option => this._filterStates(option)));
        }
        // console.log(this.form);
        this.synchtoFormbuilder();
        this.control.valueChanges.subscribe((val) => {
            this.focusEvent();
        });
    }
    synchtoFormbuilder() {
        const validators = this.fs.getFieldByName(this.name).validators;
        validators.required = this.required;
        this.fruitCtrl.setValidators(this.fs.buildValidators(validators));
        this.fruitCtrl.updateValueAndValidity();
    }
    focusEvent() {
        if (this.fs.getFormControl({ name: this.name }).value === null) {
            this.fruitCtrl.setErrors({ required: true });
            this.fruitCtrl.patchValue('');
            // this.error.nativeElement
        }
        else {
            this.fruitCtrl.setErrors({ required: false });
            this.fruitCtrl.patchValue(this.fs.getFormControl({ name: this.name }).value);
        }
        if (this.fs.getFormControl({ name: this.name }).invalid) {
            this.chipField._elementRef.nativeElement.classList.add('mat-form-field-invalid');
        }
        else {
            this.chipField._elementRef.nativeElement.classList.remove('mat-form-field-invalid');
        }
    }
    add(event) {
        const value = (event.value || '').trim();
        // Add our fruit
        if (value) {
            if (this.canAdd) {
                if (this.fruits.indexOf(value) === -1) {
                    this.fruits.push(value);
                    this.control.setValue(this.fruits.toString());
                }
            }
            else {
                if (this.actualOptions >= 0) {
                    let option = this.options[this.actualOptions];
                    if (this.fruits.indexOf(this.ts.data[option.key]) === -1) {
                        this.fruits.push(this.ts.data[option.key]);
                        this.control.setValue(this.fruits.toString());
                    }
                }
            }
        }
        // Clear the input value
        event.chipInput.clear();
        this.fruitCtrl.setValue(null);
    }
    remove(fruit) {
        const index = this.fruits.indexOf(fruit);
        if (index >= 0) {
            this.fruits.splice(index, 1);
        }
        this.fruitCtrl.updateValueAndValidity();
        this.control.setValue(this.fruits.toString());
    }
    selected(event) {
        if (this.fruits.indexOf(event.option.viewValue) === -1) {
            this.fruits.push(event.option.viewValue);
        }
        this.fruitInput.nativeElement.value = '';
        this.fruitCtrl.setValue(null);
        this.control.setValue(this.fruits.toString());
    }
    _filterStates(value) {
        this.actualOptions = -1;
        const filterValue = value ? value.toLowerCase() : '';
        let counter = 0;
        return this.options.filter(option => {
            if (this.ts.data[option.key]) {
                let index = this.ts.data[option.key].toLowerCase().indexOf(filterValue);
                if (index > -1) {
                    if (this.actualOptions === -1) {
                        this.actualOptions = counter;
                    }
                    if (!this.fruits.includes(option)) {
                        counter++;
                        return true;
                    }
                    else {
                        counter++;
                        return false;
                    }
                }
                else {
                    counter++;
                    return false;
                }
            }
            else {
                return true;
            }
        });
    }
    _filterGroup(value) {
        // console.log(this.filteredStates);
        // console.log(this.options);
        if (value && this.options[0].name) {
            return this.options
                .map((group) => ({
                name: group.name,
                children: _filter(group.children, value, this.ts)
            }))
                .filter((group) => group.name.length > 0);
        }
        // console.log(this.options);
        return this.options;
    }
}
ChipsCompleteComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ChipsCompleteComponent, deps: [{ token: i1$2.FormBuilder }, { token: FormService }, { token: TranslationService }], target: i0.ɵɵFactoryTarget.Component });
ChipsCompleteComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: ChipsCompleteComponent, selector: "app-chips-complete", inputs: { options: "options", config: "config" }, viewQueries: [{ propertyName: "fruitInput", first: true, predicate: ["fruitInput"], descendants: true }, { propertyName: "chipField", first: true, predicate: ["chipField"], descendants: true }, { propertyName: "error", first: true, predicate: ["error"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field class=\"example-chip-list\" #chipField>\n    <mat-chip-list #chipList [multiple]=\"multiple\">\n      <mat-chip *ngFor=\"let fruit of fruits\" (removed)=\"remove(fruit)\" [selectable]=\"active\">\n        {{ fruit }}\n        <button matChipRemove>\n          <mat-icon>cancel</mat-icon>\n        </button>\n      </mat-chip>\n      <input\n        matInput\n        #fruitInput\n        [placeholder]=\"getName() + '#label' | translate\"\n        [formControl]=\"fruitCtrl\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [required]=\"validators.required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        (change)=\"change.emit({ type: name, value: $event.value })\"\n        (focusout)=\"focusEvent()\"\n        [matAutocomplete]=\"auto\"\n        [matChipInputFor]=\"chipList\"\n        [matChipInputSeparatorKeyCodes]=\"separatorKeysCodes\"\n        (matChipInputTokenEnd)=\"add($event)\"\n      />\n    </mat-chip-list>\n    <mat-autocomplete\n      #auto=\"matAutocomplete\"\n      (optionSelected)=\"selected($event)\"\n    >\n    <ng-container *ngIf=\"config.groupBy\">\n      <mat-optgroup\n        *ngFor=\"let group of filteredFruits | async\"\n        [label]=\"group.name\">\n        <mat-option *ngFor=\"let item of group | async\" [matTooltip]=\"item.description | translate\" [value]=\"item.key | translate\">\n          {{item.key | translate}}\n        </mat-option>\n      </mat-optgroup>\n    </ng-container>\n    <ng-container *ngIf=\"!config.groupBy\">\n        <mat-option *ngFor=\"let item of filteredFruits | async\" [matTooltip]=\"item.description | translate\" [value]=\"item.key | translate\">\n          {{item.key | translate}}\n        </mat-option>\n    </ng-container>\n    </mat-autocomplete>\n    <mat-hint *ngIf=\"fruitCtrl.untouched || fs.getFormControl({name:this.name}).valid\">{{ (hintlabel | translate) }}</mat-hint>\n    <mat-hint class=\"error\" *ngIf=\"fruitCtrl.touched && fs.getFormControl({name:this.name}).invalid\">\n      {{ getMeesage('required', '') }}\n    </mat-hint>\n    <input matInput hidden [formControlName]=\"name\">\n  </mat-form-field>\n</ng-container>\n", styles: [".example-chip-list{width:100%}.error{color:#f44336;display:block}\n"], components: [{ type: i4$1.MatFormField, selector: "mat-form-field", inputs: ["color", "appearance", "hideRequiredMarker", "hintLabel", "floatLabel"], exportAs: ["matFormField"] }, { type: i5$4.MatChipList, selector: "mat-chip-list", inputs: ["errorStateMatcher", "multiple", "compareWith", "value", "required", "placeholder", "disabled", "aria-orientation", "selectable", "tabIndex"], outputs: ["change", "valueChange"], exportAs: ["matChipList"] }, { type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i5$2.MatAutocomplete, selector: "mat-autocomplete", inputs: ["disableRipple"], exportAs: ["matAutocomplete"] }, { type: i6.MatOptgroup, selector: "mat-optgroup", inputs: ["disabled"], exportAs: ["matOptgroup"] }, { type: i6.MatOption, selector: "mat-option", exportAs: ["matOption"] }], directives: [{ type: i5.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i1$2.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i1$2.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i5.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i5$4.MatChip, selector: "mat-basic-chip, [mat-basic-chip], mat-chip, [mat-chip]", inputs: ["color", "disableRipple", "tabIndex", "selected", "value", "selectable", "disabled", "removable"], outputs: ["selectionChange", "destroyed", "removed"], exportAs: ["matChip"] }, { type: i5$4.MatChipRemove, selector: "[matChipRemove]" }, { type: i8.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { type: i1$2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i5$2.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", exportAs: ["matAutocompleteTrigger"] }, { type: i5$4.MatChipInput, selector: "input[matChipInputFor]", inputs: ["matChipInputFor", "matChipInputAddOnBlur", "matChipInputSeparatorKeyCodes", "placeholder", "id", "disabled"], outputs: ["matChipInputTokenEnd"], exportAs: ["matChipInput", "matChipInputFor"] }, { type: i1$2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i1$2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i9.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i1$2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { type: i4$1.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { type: i1$2.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }], pipes: { "translate": TranslatePipe, "async": i5.AsyncPipe } });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: ChipsCompleteComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-chips-complete', template: "<ng-container *ngIf=\"form\" [formGroup]=\"form\">\n  <mat-form-field class=\"example-chip-list\" #chipField>\n    <mat-chip-list #chipList [multiple]=\"multiple\">\n      <mat-chip *ngFor=\"let fruit of fruits\" (removed)=\"remove(fruit)\" [selectable]=\"active\">\n        {{ fruit }}\n        <button matChipRemove>\n          <mat-icon>cancel</mat-icon>\n        </button>\n      </mat-chip>\n      <input\n        matInput\n        #fruitInput\n        [placeholder]=\"getName() + '#label' | translate\"\n        [formControl]=\"fruitCtrl\"\n        [matTooltip]=\"getName() + '#tooltip' | translate\"\n        [required]=\"validators.required\"\n        matTooltipDisabled=\"false\"\n        matTooltipHideDelay=\"200\"\n        matTooltipPosition=\"above\"\n        matTooltipShowDelay=\"100\"\n        (change)=\"change.emit({ type: name, value: $event.value })\"\n        (focusout)=\"focusEvent()\"\n        [matAutocomplete]=\"auto\"\n        [matChipInputFor]=\"chipList\"\n        [matChipInputSeparatorKeyCodes]=\"separatorKeysCodes\"\n        (matChipInputTokenEnd)=\"add($event)\"\n      />\n    </mat-chip-list>\n    <mat-autocomplete\n      #auto=\"matAutocomplete\"\n      (optionSelected)=\"selected($event)\"\n    >\n    <ng-container *ngIf=\"config.groupBy\">\n      <mat-optgroup\n        *ngFor=\"let group of filteredFruits | async\"\n        [label]=\"group.name\">\n        <mat-option *ngFor=\"let item of group | async\" [matTooltip]=\"item.description | translate\" [value]=\"item.key | translate\">\n          {{item.key | translate}}\n        </mat-option>\n      </mat-optgroup>\n    </ng-container>\n    <ng-container *ngIf=\"!config.groupBy\">\n        <mat-option *ngFor=\"let item of filteredFruits | async\" [matTooltip]=\"item.description | translate\" [value]=\"item.key | translate\">\n          {{item.key | translate}}\n        </mat-option>\n    </ng-container>\n    </mat-autocomplete>\n    <mat-hint *ngIf=\"fruitCtrl.untouched || fs.getFormControl({name:this.name}).valid\">{{ (hintlabel | translate) }}</mat-hint>\n    <mat-hint class=\"error\" *ngIf=\"fruitCtrl.touched && fs.getFormControl({name:this.name}).invalid\">\n      {{ getMeesage('required', '') }}\n    </mat-hint>\n    <input matInput hidden [formControlName]=\"name\">\n  </mat-form-field>\n</ng-container>\n", styles: [".example-chip-list{width:100%}.error{color:#f44336;display:block}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$2.FormBuilder }, { type: FormService }, { type: TranslationService }]; }, propDecorators: { options: [{
                type: Input
            }], config: [{
                type: Input
            }], fruitInput: [{
                type: ViewChild,
                args: ['fruitInput']
            }], chipField: [{
                type: ViewChild,
                args: ['chipField']
            }], error: [{
                type: ViewChild,
                args: ['error']
            }] } });

registerLocaleData(localeDe, 'de');
class FormbuilderModule {
    static forRoot() {
        return {
            ngModule: FormbuilderModule,
            providers: [
                TranslationService,
                ConfigService,
                DataFlattnerService,
                TranslatePipe
            ]
        };
    }
}
FormbuilderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
FormbuilderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, bootstrap: [FormbuilderComponent], declarations: [FormbuilderComponent,
        BaseFieldComponent,
        SelectComponent,
        TextInputComponent,
        DateInputComponent,
        FileInputComponent,
        AutocompleteComponent,
        CheckboxComponent,
        RadiobuttonComponent,
        SliderComponent,
        TranslatePipe,
        ConfirmDialogComponent,
        ErrorDialogSimpleComponent,
        InfoDialogSimpleComponent,
        TableComponent,
        SlideToggleComponent,
        CheckBoxGroupComponent,
        ChipsCompleteComponent], imports: [BrowserModule,
        CommonModule,
        HttpClientModule,
        MatIconModule,
        ReactiveFormsModule,
        FormsModule,
        MatFormFieldModule,
        MatInputModule,
        MatListModule,
        MatGridListModule,
        MatCardModule,
        MatSelectModule,
        MatAutocompleteModule,
        MatDatepickerModule,
        MatMomentDateModule,
        BrowserAnimationsModule,
        MatCheckboxModule,
        MatStepperModule,
        MatTooltipModule,
        MatTreeModule,
        MatButtonModule,
        MatSidenavModule,
        MatExpansionModule,
        MatRadioModule,
        MatDialogModule,
        MatTableModule,
        MatSortModule,
        MatPaginatorModule,
        MatSliderModule,
        MatSlideToggleModule,
        MatChipsModule], exports: [FormbuilderComponent,
        SelectComponent,
        TextInputComponent,
        DateInputComponent,
        FileInputComponent,
        AutocompleteComponent,
        CheckboxComponent,
        RadiobuttonComponent,
        SliderComponent,
        TableComponent,
        SlideToggleComponent,
        TranslatePipe,
        CheckBoxGroupComponent,
        ChipsCompleteComponent] });
FormbuilderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, providers: [
        { provide: MAT_DATE_LOCALE, useValue: 'de' },
        { provide: DateAdapter, useClass: MomentDateAdapter, deps: [MAT_DATE_LOCALE] },
        { provide: MAT_DATE_FORMATS, useValue: MAT_MOMENT_DATE_FORMATS },
        TranslatePipe
    ], imports: [[
            BrowserModule,
            CommonModule,
            HttpClientModule,
            MatIconModule,
            ReactiveFormsModule,
            FormsModule,
            MatFormFieldModule,
            MatInputModule,
            MatListModule,
            MatGridListModule,
            MatCardModule,
            MatSelectModule,
            MatAutocompleteModule,
            MatDatepickerModule,
            MatMomentDateModule,
            BrowserAnimationsModule,
            MatCheckboxModule,
            MatStepperModule,
            MatTooltipModule,
            MatTreeModule,
            MatButtonModule,
            MatSidenavModule,
            MatExpansionModule,
            MatRadioModule,
            MatDialogModule,
            MatTableModule,
            MatSortModule,
            MatPaginatorModule,
            MatSliderModule,
            MatSlideToggleModule,
            MatChipsModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        FormbuilderComponent,
                        BaseFieldComponent,
                        SelectComponent,
                        TextInputComponent,
                        DateInputComponent,
                        FileInputComponent,
                        AutocompleteComponent,
                        CheckboxComponent,
                        RadiobuttonComponent,
                        SliderComponent,
                        TranslatePipe,
                        ConfirmDialogComponent,
                        ErrorDialogSimpleComponent,
                        InfoDialogSimpleComponent,
                        TableComponent,
                        SlideToggleComponent,
                        CheckBoxGroupComponent,
                        ChipsCompleteComponent
                    ],
                    imports: [
                        BrowserModule,
                        CommonModule,
                        HttpClientModule,
                        MatIconModule,
                        ReactiveFormsModule,
                        FormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatListModule,
                        MatGridListModule,
                        MatCardModule,
                        MatSelectModule,
                        MatAutocompleteModule,
                        MatDatepickerModule,
                        MatMomentDateModule,
                        BrowserAnimationsModule,
                        MatCheckboxModule,
                        MatStepperModule,
                        MatTooltipModule,
                        MatTreeModule,
                        MatButtonModule,
                        MatSidenavModule,
                        MatExpansionModule,
                        MatRadioModule,
                        MatDialogModule,
                        MatTableModule,
                        MatSortModule,
                        MatPaginatorModule,
                        MatSliderModule,
                        MatSlideToggleModule,
                        MatChipsModule
                    ],
                    providers: [
                        { provide: MAT_DATE_LOCALE, useValue: 'de' },
                        { provide: DateAdapter, useClass: MomentDateAdapter, deps: [MAT_DATE_LOCALE] },
                        { provide: MAT_DATE_FORMATS, useValue: MAT_MOMENT_DATE_FORMATS },
                        TranslatePipe
                    ],
                    bootstrap: [FormbuilderComponent],
                    exports: [
                        FormbuilderComponent,
                        SelectComponent,
                        TextInputComponent,
                        DateInputComponent,
                        FileInputComponent,
                        AutocompleteComponent,
                        CheckboxComponent,
                        RadiobuttonComponent,
                        SliderComponent,
                        TableComponent,
                        SlideToggleComponent,
                        TranslatePipe,
                        CheckBoxGroupComponent,
                        ChipsCompleteComponent
                    ]
                }]
        }] });

class DataConnectorService {
    constructor(http) {
        this.http = http;
        this.url = 'api';
    }
    create(post, itemType) {
        return this.http.post('/api/' + itemType, { ['item']: post }, { headers: { 'Content-Type': 'application/json' } });
    }
    update(id, post, itemType) {
        if (post) {
            return this.http.put('/api/' + itemType, { ['item']: post }, { headers: { 'Content-Type': 'application/json' } });
        }
        return 'incoorect input';
    }
    get(itemType, id = "0", kat = [], txt = '') {
        let res;
        res = [];
        let search = {};
        if (id !== '0') {
            search.id = id;
        }
        if (kat && kat.length > 0) {
            search.categories = kat;
        }
        if (txt !== '') {
            search.text = txt;
        }
        let options = {
            headers: new HttpHeaders({ 'Content-Type': 'application/json' }),
            params: search
        };
        return this.http.get('/api/' + itemType, options);
    }
    delete(id, itemType) {
        if (id) {
            return this.http.delete('/api/' + itemType, {
                headers: { 'Content-Type': 'application/json' },
                params: { id: id }
            });
        }
        return 'no id';
    }
    getFields() {
        return this.http.get(this.url + '/get');
    }
    insertField(field) {
        return this.http.post(this.url + '/insert', field);
    }
    deleteField(id) {
        return this.http.delete(this.url + '/delete', id);
    }
    getAsyncValidation(url, body) {
        return this.http.post(url, body).pipe(map(value => {
            if (value) {
                return value;
            }
            else {
                return timer(2000).pipe(map(() => {
                    return { 'error': true };
                }));
            }
        }));
    }
}
DataConnectorService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataConnectorService, deps: [{ token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable });
DataConnectorService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataConnectorService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataConnectorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }]; } });

class UserService {
    constructor(http, dialogService) {
        this.http = http;
        this.dialogService = dialogService;
        this.headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Charset', 'UTF-8');
        this.options = { headers: this.headers };
        this.apiBaseUrl = '/api';
    }
    login(credentials, url) {
        const headers = new HttpHeaders()
            .set('Content-Type', 'application/json')
            .set('Charset', 'UTF-8')
            .set('Authorization', 'Basic ' + btoa(credentials));
        const options = {
            headers: headers,
            observe: 'response',
            withCredentials: true
        };
        return this.http.post(url, null, options);
    }
    logout(url) {
        this.options = { headers: this.headers };
        return this.http.delete(url, this.options);
    }
    /**
     * Gets current users profile.
     */
    getUserProfile(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        // return this.http.get(this.apiBaseUrl + `user/profile`, options);
        return this.http.get(url, this.options);
    }
    /**
     * Get the allowed actions of the current user
     */
    getUserRoles(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        // return this.http.get(this.apiBaseUrl + `user/role`, options)
        //   .pipe(
        //     map(value => value['actions'])
        //   );
        return this.http.get(url, this.options);
    }
    /**
     * get all users
     */
    getUsers(url) {
        // const headers = this.headers.set('useMockup', 'true');
        // const options = {headers: headers};
        return this.http.get(url, this.options);
    }
    getUser(url, userId) {
        return this.http.get(`${url}${userId}`, this.options);
    }
    addUser(url, user) {
        return this.http.post(url, JSON.stringify(user), this.options);
    }
    addUserAndRoles(url, user) {
        // check if bkuUser already exists
        const done = new ReplaySubject(1);
        this.addUser(url, user).subscribe(addUserRes => {
            user.id = addUserRes.id;
            this.updateRoles(url, user).subscribe(updateRoleResp => done.next(updateRoleResp));
        }, error => {
            this.dialogService.showErrorDialog('Error');
        });
        return done;
    }
    editUser(url, user) {
        return this.http.put(`${url}${user.id}`, JSON.stringify(user), this.options);
    }
    editUserAndRoles(url, user) {
        return forkJoin(this.editUser(url, user), this.updateRoles(url, user));
    }
    deleteUser(url, user) {
        return this.http.delete(`${url}${user.id}`, this.options);
    }
    updateRoles(url, user) {
        const rolesObject = {
            'roles': user.roles
        };
        return this.http.put(`${url}${user.id}`, JSON.stringify(rolesObject), this.options);
    }
}
UserService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: UserService, deps: [{ token: i1.HttpClient }, { token: DialogService }], target: i0.ɵɵFactoryTarget.Injectable });
UserService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: UserService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: UserService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }, { type: DialogService }]; } });

class DataStoreService {
    constructor() {
        this.navbarVisibility = new BehaviorSubject(true);
        this.currentUser = new ReplaySubject(1);
        this.allowedActions = new ReplaySubject(1);
    }
    showNavbar(shouldNavbarBeVisible) {
        this.navbarVisibility.next(shouldNavbarBeVisible);
    }
    getNavbarState() {
        return this.navbarVisibility;
    }
    getCurrentUser() {
        return this.currentUser;
    }
    setCurrentUser(value) {
        this.currentUser.next(value);
    }
    getAllowedActions() {
        return this.allowedActions;
    }
    setAllowedActions(value) {
        this.allowedActions.next(value);
    }
}
DataStoreService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataStoreService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DataStoreService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataStoreService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: DataStoreService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class AuthenticationService {
    constructor(router, userService, dataStore) {
        this.router = router;
        this.userService = userService;
        this.dataStore = dataStore;
        this._isLoggedIn = false;
        this.bla = 'fbapp-user';
        this.registerCurrentUser();
        this.registerAllowedActions();
        const storedUserProfile = this.loadUserProfile();
        //const storedAllowedActions = this.loadAllowedActions();
        if (!!storedUserProfile) {
            this.dataStore.setCurrentUser(storedUserProfile);
        }
        /*
        if (!!storedAllowedActions) {
          this.dataStore.setAllowedActions(storedAllowedActions);
        }
    */
    }
    /*
    hasAvailableAction(systemResource: SystemResource, systemAction: SystemAction) {
      if (systemResource && systemAction && this.allowedActions && systemResource in this.allowedActions) {
        const roles: Object = this.allowedActions[systemResource];
        const allActionsWithDuplicates = Object.values(roles)
          .reduce((previousValue, currentValue) => {
            return previousValue.concat(currentValue);
          });
        const availableActions = Array.from(new Set(allActionsWithDuplicates)); // [C, C, R, R, U] => [C, R, U]
        if (!!availableActions && availableActions.indexOf(systemAction) >= 0) {
          return true;
        }
      }
      return false;
    }
  
    hasRole(systemRole: SystemRole) {
      if (!systemRole || !this.currentUser) {
        return false;
      }
  
      const currentUserRoles: string[] = this.currentUser.roles;
      if (currentUserRoles.indexOf(systemRole) >= 0) {
        return true;
      }
      return false;
    }
  */
    login(loginurl, username, password) {
        const usernameAndPassword = username + ':' + password;
        return this.userService.login(usernameAndPassword, loginurl).pipe(tap(resp => {
            // console.log('[authenticationService] - login successful', resp);
            this.isLoggedIn = true;
        }), tap(() => {
            // this.getUserProfile();
        }), tap(() => {
            // this.getUserActions();
        }));
    }
    getUserProfile(url) {
        this.userService.getUserProfile(url).subscribe((profile) => {
            // console.log('[AuthenticationService] - getUserProfile', profile);
            this.dataStore.setCurrentUser(profile);
        }, errObj => {
            throwError(errObj);
        });
    }
    /*
    getUserActions() {
      this.userService.getUserRoles().subscribe((actionResp: Object) => {
        if (actionResp.hasOwnProperty('actions')) {
          // console.log('[AuthenticationService] - getUserActions', actionResp);
          this.dataStore.setAllowedActions(actionResp['actions']);
        } else {
          this.dataStore.setAllowedActions(null);
        }
      }, (errObj) => {
        throwError(errObj);
      });
    }
  */
    logout(navigateToLoginpage = true, url) {
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        // this.dataStore.setAllowedActions(null);
        this.userService.logout(url).subscribe(null, null, () => {
            if (navigateToLoginpage) {
                this.navigateToLoginPage();
            }
        });
    }
    /**
     * Removes Authentication Informations from Localstorage
     * and navigates to the loginpage.
     */
    handleSessionTimeout() {
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        //this.dataStore.setAllowedActions(null);
        this.navigateToLoginPage();
    }
    /**
     * Checks currently only if the userProfile is stored locally
     * FIXME: An additional test for a valid cookie would be more useful.
     */
    checkIfUserIsAlreadyLoggedIn() {
        const storedUserProfile = this.loadUserProfile();
        const storedAllowedActions = true; //his.loadAllowedActions();
        if (!!storedUserProfile && !!storedAllowedActions) {
            this.isLoggedIn = true;
            this.dataStore.setCurrentUser(storedUserProfile);
            // this.dataStore.setAllowedActions(storedAllowedActions);
            return true;
        }
        this.isLoggedIn = false;
        this.dataStore.setCurrentUser(null);
        //this.dataStore.setAllowedActions(null);
        return false;
    }
    navigateToLoginPage() {
        this.router.navigate(['login']);
    }
    loadUserProfile() {
        let res = localStorage.getItem(this.bla);
        return res ? JSON.parse(res) : '';
    }
    saveUserProfile(userProfile) {
        // console.log('saveUserProfile', userProfile);
        if (!!userProfile) {
            localStorage.setItem(this.bla, JSON.stringify(userProfile));
        }
        else {
            localStorage.removeItem(this.bla);
        }
    }
    /*
    loadAllowedActions(): any {
      return JSON.parse(localStorage.getItem(this.USER_ALLOWED_ACTIONS));
    }
  
    saveAllowedActions(actions: any): void {
      // console.log('saveAllowedActions', actions);
      if (!!actions && Object.keys(actions).length > 0) {
        localStorage.setItem(this.USER_ALLOWED_ACTIONS, JSON.stringify(actions));
      } else {
        localStorage.removeItem(this.USER_ALLOWED_ACTIONS);
      }
    }
  */
    get isLoggedIn() {
        return this._isLoggedIn;
    }
    set isLoggedIn(value) {
        this._isLoggedIn = value;
    }
    registerCurrentUser() {
        this.dataStore.getCurrentUser().subscribe((user) => {
            this.currentUser = user;
            this.saveUserProfile(user);
        });
    }
    registerAllowedActions() {
        this.dataStore.getAllowedActions().subscribe((actions) => {
            this.allowedActions = actions;
            //this.saveAllowedActions(actions);
        });
    }
}
AuthenticationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: AuthenticationService, deps: [{ token: i1$3.Router }, { token: UserService }, { token: DataStoreService }], target: i0.ɵɵFactoryTarget.Injectable });
AuthenticationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: AuthenticationService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: AuthenticationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$3.Router }, { type: UserService }, { type: DataStoreService }]; } });

/*
 * Public API Surface of formbuilder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AngularCsv, AuthenticationService, AutocompleteComponent, BaseFieldComponent, CheckBoxGroupComponent, CheckboxComponent, ChipsCompleteComponent, ConfigService, CsvConfigConsts, DataConnectorService, DataFlattnerService, DateInputComponent, DialogService, FileInputComponent, FormService, FormbuilderComponent, FormbuilderModule, FormbuilderService, RadiobuttonComponent, SelectComponent, SlideToggleComponent, SliderComponent, TableComponent, TableType, TextInputComponent, TranslatePipe, TranslationService, UserService, _filter, checkKey };
//# sourceMappingURL=formbuilder.mjs.map
