import { HttpClient } from '@angular/common/http';
import * as i0 from "@angular/core";
export interface searchObj {
    id?: string;
    categories?: string[];
    text?: string;
}
export declare class DataConnectorService {
    private http;
    url: string;
    constructor(http: HttpClient);
    create(post: any, itemType: string): import("rxjs").Observable<Object>;
    update(id: string, post: any, itemType: string): import("rxjs").Observable<Object> | "incoorect input";
    get(itemType: string, id?: string, kat?: string[], txt?: string): import("rxjs").Observable<Object>;
    delete(id: string, itemType: string): import("rxjs").Observable<Object> | "no id";
    getFields(): import("rxjs").Observable<Object>;
    insertField(field: any): import("rxjs").Observable<Object>;
    deleteField(id: any): import("rxjs").Observable<ArrayBuffer>;
    getAsyncValidation(url: string, body: any): import("rxjs").Observable<Object>;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataConnectorService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DataConnectorService>;
}
