import { BehaviorSubject, ReplaySubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class DataStoreService {
    private navbarVisibility;
    private currentUser;
    private allowedActions;
    constructor();
    showNavbar(shouldNavbarBeVisible: boolean): void;
    getNavbarState(): BehaviorSubject<boolean>;
    getCurrentUser(): ReplaySubject<any>;
    setCurrentUser(value: any): void;
    getAllowedActions(): ReplaySubject<Object>;
    setAllowedActions(value: Object): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DataStoreService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DataStoreService>;
}
