import { MatDialog, MatDialogRef } from '@angular/material/dialog';
import * as i0 from "@angular/core";
export declare class DialogService {
    private dialog;
    constructor(dialog: MatDialog);
    showDataImportErrorDialog(errorDataArray: any[], afterDialogCallback: Function): MatDialogRef<any>;
    showErrorDialog(errorMsg: any, afterDialogCallback?: Function): MatDialogRef<any>;
    showInfoDialog(infoMsg: any, afterDialogCallback?: Function): MatDialogRef<any>;
    /**
     * messageString may also be an html String like:
     * <b>Are you sure?</b>
     *
     * @param {string} messageString
     * @param {Function} positiveCallback
     * @param {Function} negativeCallback
     */
    confirm(messageString: string, positiveCallback: Function, negativeCallback?: Function): void;
    xmlExport(positiveCallback: Function, negativeCallback?: Function): void;
    setValid(positiveCallback: Function, negativeCallback?: Function): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DialogService>;
}
