import { OnInit } from '@angular/core';
import { BaseFieldComponent } from '../../classes/field';
import { FormBuilder } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { IAutoCompleteOptions } from '../../interfaces/iautocompleteoption';
import { TranslationService } from '../../services/translation.service';
import * as i0 from "@angular/core";
export declare const _filter: (opt: any[], value: string, ts: TranslationService) => string[];
export declare function checkKey(ts: TranslationService, item: string, value: string): boolean;
export declare class AutocompleteComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    filteredStates: any;
    options: any[];
    config: IAutoCompleteOptions;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    ngOnInit(): void;
    private _filterStates;
    private _filterGroup;
    static ɵfac: i0.ɵɵFactoryDeclaration<AutocompleteComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AutocompleteComponent, "app-autocomplete", never, { "options": "options"; "config": "config"; }, {}, never, never>;
}
