import { OnInit } from '@angular/core';
import { BaseFieldComponent } from '../../classes/field';
import { FormBuilder } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { TranslationService } from '../../services/translation.service';
import { ThemePalette } from '@angular/material/core';
import * as i0 from "@angular/core";
export interface ICheckboxGroup {
    name: string;
    completed: boolean;
    color: ThemePalette;
    subtasks?: ICheckboxGroup[];
}
export declare class CheckboxComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    position: string;
    options: ICheckboxGroup;
    allComplete: boolean;
    updateAllComplete(): void;
    someComplete(): boolean;
    setAll(completed: boolean): void;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckboxComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CheckboxComponent, "app-checkbox", never, { "position": "position"; "options": "options"; }, {}, never, never>;
}
