import { OnInit } from '@angular/core';
import { BaseFieldComponent } from '../../classes/field';
import { FormBuilder, FormControl } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { DateAdapter } from '@angular/material/core';
import { TranslationService } from '../../services/translation.service';
import * as i0 from "@angular/core";
export declare class DateInputComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    private dateAdapter;
    ts: TranslationService;
    constructor(fb: FormBuilder, fs: FormService, dateAdapter: DateAdapter<any>, ts: TranslationService);
    ngOnInit(): void;
    isMoment(date: FormControl): void;
    keyup(): void;
    keydown(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DateInputComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DateInputComponent, "app-date-input", never, {}, {}, never, never>;
}
