import { OnInit } from '@angular/core';
import { ISliderConfig } from '../../interfaces/isliderconfig';
import { FormBuilder } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { BaseFieldComponent } from '../../classes/field';
import { TranslationService } from '../../services/translation.service';
import * as i0 from "@angular/core";
export declare class SliderComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    config: ISliderConfig;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    ngOnInit(): void;
    getTickIntervall(): number | "auto";
    static ɵfac: i0.ɵɵFactoryDeclaration<SliderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SliderComponent, "app-slider", never, { "config": "config"; }, {}, never, never>;
}
