import { IField } from '../interfaces/ifield';
import { AutoSearch } from '../interfaces/imenu';
import { BehaviorSubject } from 'rxjs';
import { HttpClient } from '@angular/common/http';
import * as i0 from "@angular/core";
export declare class ConfigService {
    private http;
    flatControlls: any[];
    dataChange: BehaviorSubject<AutoSearch[]>;
    configs: any;
    emptyObj: IField;
    constructor(http: HttpClient);
    buildTree(config: any): void;
    get data(): AutoSearch[];
    /**
     * Build the file structure tree. The `value` is the Json object, or a sub-tree of a Json object.
     * The return value is the list of `AutoSearch`.
     */
    buildFileTree(obj: {
        [key: string]: any;
    }, level: number): AutoSearch[];
    getControlls(): any[];
    getFlatControlls(): {};
    getConfigByName(name: string): IField;
    getAppConfigs(appData: any[]): {};
    getFBConfig(appData: any[]): {};
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfigService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ConfigService>;
}
