import { OnInit } from '@angular/core';
import { BaseFieldComponent } from '../../classes/field';
import { FormBuilder } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { TranslationService } from '../../services/translation.service';
import { ThemePalette } from '@angular/material/core';
import * as i0 from "@angular/core";
export interface CheckboxGroup {
    name: string;
    completed: boolean;
    color: ThemePalette;
    subtasks?: CheckboxGroup[];
}
export declare class CheckBoxGroupComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    position: string;
    options: CheckboxGroup;
    allComplete: boolean;
    updateAllComplete(): void;
    someComplete(): boolean;
    setAll(completed: boolean): void;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckBoxGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CheckBoxGroupComponent, "app-check-box-group", never, { "position": "position"; }, {}, never, never>;
}
