import { OnInit } from '@angular/core';
import { BaseFieldComponent } from '../../classes/field';
import { FormBuilder } from '@angular/forms';
import { FormService } from '../../services/form.service';
import { ICodeEntry } from '../../interfaces/ifield';
import { TranslationService } from '../../services/translation.service';
import * as i0 from "@angular/core";
export declare class SelectComponent extends BaseFieldComponent implements OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    options?: ICodeEntry[];
    multiple: boolean;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SelectComponent, "app-select", never, { "options": "options"; "multiple": "multiple"; }, {}, never, never>;
}
